 ###############################################
#                                               #
#       I N T E R F A C E   M E G A H A L       #
#     v3.1.0 (26/12/2010)  2010 MenzAgitat     #
#         pour MegaHAL v8 (module v3.4)         #
#                                               #
#   IRC: irc.epiknet.org  #eggdrop / #boulets   #
#                                               #
#     Mes scripts sont tlchargeables sur      #
#            http://www.eggdrop.fr              #
#                                               #
 ###############################################

# Remerciements  Artix et  Galdinx pour les coups de main.
# Merci galement  wiki.tcl.tk pour une ou deux routines fort utiles
# (notamment celle permettant d'ajuster automatiquement l'unit de mesure
# utilise pour exprimer la taille de l'IA en octets)

# MegaHAL Interface est une interface pour le module MegaHAL dvelopp par
# Zev ^Baron^ Toledano et modifi par Artix, d'aprs l'I.A. de Jason Hutchens.
# Ce script ne fonctionnera correctement qu'avec la version 3.4 du module
# MegaHAL modifi par Artix (Artixed Edition 3); elle est normalement fournie
# avec si vous avez rcupr ce script au bon endroit.
# Remarque : si vous choisissez de ne pas utiliser la version fournie du module
# et que vous avez des problmes, ne venez pas m'en parler.
#
# Le but de cette interface est d'accrotre le contrle que vous avez sur
# MegaHAL et d'ajouter de nombreuses fonctionnalits et amliorations dont
# voici la liste :
#		- Tout est en franais.
#		- Contrle de l'I.A. par flags (donc par chan) :
#				+/-megahal					:	Active/dsactive la possibilit d'utiliser MegaHAL
#															sur un chan donn.
#															Ce flag est prioritaire sur les autres flags.
#				+/-megahal_respond	:	Active/dsactive les rponses du bot quand un
#															mot-cl (son nick par exemple) est mentionn sur
#															un chan donn.
#				+/-megahal_chatter	:	Active/dsactive les rponses spontanes du bot
#															sur un chan donn (c'est  dire sans qu'il soit
#															sollicit). 
#				+/-megahal_learn		:	Active/dsactive l'apprentissage sur un chan donn.
#				Notez que ces flags sont tous dsactivs par dfaut si c'est la premire
#				fois que vous utilisez ce script.
# 			Remarque : si le flag -megahal est appliqu sur un chan, les seules
#				commandes publiques qui fonctionnent sont ".megahal on/off" et
#				".megahal_status"
#		- Caractres spciaux utilisables en dbut de ligne :
#				&		=		apprentissage forc		+		rponse force
#				%		=		n'apprend pas					+		rponse force
#				~		=		apprentissage forc		+		ne rpond pas
#				$		=		n'apprend pas					+		ne rpond pas
#				Remarque : 	attention, & et ~ sont ultra-prioritaires et rien
#										n'interdira au bot d'apprendre une commande par exemple;
#										faites attention  qui vous donnez l'autorisation d'utiliser
#										ces 2 symboles.
#		- Commande d'aide n'affichant que les commandes auxquelles vous avez droit
#			en fonction de votre accs.
#		- nombreuses commandes publiques :
#				.aide_megahal		affiche la liste des commandes spcifiques  MegaHAL
#				.megahal				active/dsactive l'I.A. sur un chan
#												(contrle le flag megahal)
#				.learn					active/dsactive l'apprentissage sur un chan
#												(contrle le flag megahal_learn)
#				.respond				active/dsactive la rponse de l'I.A. en cas de mot cl dtect
#												(contrle le flag megahal_respond)
#				.chatter				active/dsactive la libre expression
#												(contrle le flag megahal_chatter)
#				.replyrate			affiche/modifie le taux de rponse libre
#				.keyreplyrate		affiche/modifie le taux de rponse en cas de mot cl dtect
#				.forget					demande  l'I.A. d'oublier une phrase
#				.forgetword			demande  l'I.A. d'oublier un mot
#				.seekstatement	vrifie si l'I.A. connait une phrase donne
#				.countword			vrifie si l'I.A. connait un mot donn et en compte toutes les occurrences
#				.learnfile			demande  l'I.A. d'apprendre le contenu d'un fichier
#				.savebrain			sauvegarde le cerveau
#				.reloadbrain		recharge le cerveau
#				.reloadphrases	recharge les phrases (depuis le fichier .phr)
#				.trimbrain			effectue un lagage du cerveau
#				.lobotomy				effectue un lavage de cerveau
#				.restorebrain		restaure un backup du cerveau
#				.megahal_status	affiche le statut de l'I.A. sur le chan en cours
#				.braininfo			affiche des informations sur l'I.A.
#				.memusage				affiche une estimation de la quantit de mmoire occupe par l'I.A.
#				.treesize				affiche la taille d'une arborescence
#				.viewbranch			affiche le contenu d'une branche de l'arborescence
#		- Rgler  votre convenance les commandes et les autorisations pour chacune.
#		- Dfinir un dlai pour l'activation de l'I.A. aprs la connexion de
#			l'eggdrop au serveur afin de rduire l'encombrement des files d'attente.
#		- Choisir des mots cls qui provoqueront forcment une rponse.
#			(variables acceptes)
#		- Exclure certains nicks/handles de l'apprentissage : MegaHAL n'apprendra
#			jamais ce qu'ils disent.
#		- Exclure certais nicks/handles des rponses : MegaHAL ne leur rpondra
#			jamais.
#		- Dfinir une liste de mots (jokers accepts) que l'I.A. ne doit jamais
#			apprendre.
#		- Rgler indpendamment le taux de rponse libre, le taux de rponse en
#			raction  un mot cl, et le taux d'apprentissage.
#			Les taux sont exprims en %.
#		- Dfinir une longueur minimale en mots afin d'empcher l'I.A. d'apprendre
#			des phrases trop courtes.
#		- Choisir la longueur maximale en mots des rponses de MegaHAL
#			(fonctionnalit d'origine du module).
#		- Apprendre APRES avoir rpondu, afin que la rponse ne soit pas influence
#			par ce qu'il vient juste d'apprendre.
#		- Substituer le nick du bot par le nick de la personne  qui il rpond
#			selon un pourcentage de chances.
#		- Substituer les nicks des personnes prsentes sur le chan par des symboles
#			lors de l'apprentissage, puis les substituer  nouveau par des nicks de
#			personnes prsentes sur le chan lorsqu'ils seront rutiliss par l'IA.
#			( l'exceptions de certains nicks que vous pouvez choisir)
#		- Choisir la taille maximale du contexte.
#			(fonctionnalit d'origine du module).
#		- Mode surprise autorisant l'I.A.  prendre plus de liberts.
#			(fonctionnalit d'origine du module).
#		- Choisir quels caractres sont considrs comme fin de mot.
#			Exemple : les virgules mme si elles ne sont pas prcdes ou suivies
#			d'un espace
#		- Choisir quels caractres sont considrs comme sparateurs de mots et ne
#			seront par consquent pas appris.
#			Exemple : les espaces
#		- Choisir quels caractres ne doivent pas tre dissocis d'un mot.
#			Exemple : le trait d'union dans porte-monnaie
#		- Simuler le temps de frappe car un bot qui rpond instantanment brise
#			l'illusion.
#		- Empcher l'I.A. d'apprendre le contenu des copier/coller et le flood en
#			imposant un dlai minimum entre 2 apprentissages venant de la mme
#			personne.
#		- Empcher que l'I.A. envoie un flood de rponses (par exemple en raction
#			 un copier/coller dont chaque ligne mentionne le nom du bot) en imposant
#			un dlai minimum entre 2 rponses du bot  une mme personne.
#		- Protection anti-flood afin d'empcher que MegaHAL rponde plus de x fois
#			en y secondes.
#		- Possibilit de faire taire le bot pendant un certain temps en lui
#			demandant gentiment (ou pas).
#		- Les rponses de MegaHAL sont places dans une file d'attente ddie dont
#			la taille maximum peut tre contrle.
#		- Choisir la taille maximale du cerveau en nombre d'associations (galement
#			appeles nodes) (fonctionnalit d'origine du module)
#		- Modifier le temps imparti  la gnration d'une rponse par MegaHAL
#			(par dfaut 1 seconde).
#		- Possibilit d'activer/dsactiver le mode debug du module. Ce mode permet
#			au module d'afficher des informations sur le contexte en cas de crash mais
#			consomme plus de mmoire.
#		- Possibilit d'afficher alatoirement une rponse double dont l'une des
#			deux est une rponse neutre choisie alatoirement dans une liste.
#			La deuxime rponse neutre peut intervenir avant ou aprs la rponse
#			de MegaHAL. Voici un exemple :
#				<MenzAgitat> fais gaffe, je crois que t'es un bot.
#				<bot> ou pas
#				<bot> fais gaffe, t'es sur #boulets
#		- Mode dbogage  plusieurs niveaux affichant des informations dtailles
#			en partyline en ce qui concerne le fonctionnement de l'interface MegaHAL.
#			Des codes couleur sont utiliss afin que le flot d'information soit
#			facilement lisible (rend beaucoup mieux sur fond noir que sur fond blanc).
#			Voir la section paramtres pour des explications dtailles.
#		- Sauvegarde automatique du cerveau toutes les heures ainsi qu'avant un
#			rehash / restart / ... , et optionnellement un die.
#		- Cration automatique d'une copie de sauvegarde des bases de donnes de
#			l'I.A. chaque jour  une heure dfinie.
#		- Procdure de dsinstallation intgre au script afin de lui garantir une
#			dsinstallation propre  chaque re-lecture.
#		- Suppression des balises "fin de couleur" (\017) que MegaHAL apprend
#			par dfaut.
#		- Empche l'I.A. d'apprendre des commandes et de les rutiliser (vous pouvez
#			dfinir des exceptions)
#		- Filtres d'apprentissages :
#				- viter au maximum que le bot apprenne son propre nom afin d'viter
#					qu'il le rutilise  outrance
#				- viter d'apprendre les <nick> dans les copier/coller
#				- viter d'apprendre les timestamps dans les copier/coller
#				- personnifier le bot afin qu'il reconnaisse mieux quand on parle
#					de lui et que ses rponses refltent sa conscience de soi.
#		- Filtres sur les rponses :
#				- viter au maximum que le bot utilise son propre nick dans ses
#					phrases
#				- personnifier le bot afin qu'il reconnaisse mieux quand on parle
#					de lui et que ses rponses refltent sa conscience de soi.
#				- corriger certaines incohrences de langage rcurrentes
#				- corriger certaines fautes grammaticales rcurrentes
#				- corriger la casse de smileys qui ont besoin de capitales pour
#					conserver leur signification
#				- corriger la casse des nicks des personnes prsentes sur le chan
#					(sans quoi Megahal met tout en minuscules)
#				- augmenter le ralisme des rponses par certaines astuces simples
#					(comme par exemple remplacer "pourquoi" en dbut de phrase par
#					"parce que" afin que le bot ne rponde pas "pourquoi"  "pourquoi").
#		- Log des rponses de MegaHAL dans les logs de chan de l'eggdrop. (en temps
#			normal, l'eggdrop ne se log pas lui-mme)
#
# Voici les commandes  taper pour activer compltement l'I.A. sur un chan :
# 	.megahal on		(active la possibilit d'utiliser MegaHAL sur ce chan)
#		.learn on			(active l'apprentissage sur ce chan)
#		.respond on		(active la rponse de l'I.A. en cas de mot cl dtect)
#		.chatter on		(active la libre expression)
# Ces commandes sont  taper sur le chan sur lequel vous dsirez activer
# MegaHAL. Notez que .megahal on/off agit comme un interrupteur global, vous
# permettant d'activer/dsactiver entirement MegaHAL sur ce chan via une seule
# commande, mais que son utilisation ne change rien  l'tat des 3 autres
# interrupteurs (learn, respond et chatter), qui ncessitent d'tre activs
# indpendamment.
#
# Si vous venez juste d'installer Interface MegaHAL et que votre bot possde
# dj un brain, il est recommand de lui effacer la mmoire (au moyen de la
# commande .lobotomy) afin de profiter pleinement des capacits de ce script.
# 
# Remarque importante :
# 	Si vous utilisez des caractres spciaux dans le nom de votre eggdrop, ce
#		script pourrait ne pas fonctionner correctement tant donn qu'il effectue
#		des recherches par regexp sur $::botnick. A l'origine, ce script n'a pas t
#		ralis dans le but d'tre publi et le rendre totalement universel n'a
#		jamais t mon intention.
#
# Veuillez maintenant vous reporter  la section paramtres ci-aprs.
#

#
# Changelog
#
# 3.0.0	-	1re release publique
# 3.1.0	-	Correction des rglages par dfaut des options megawc_boundary et
#					megawc_glue : les caractres [ et ] n'taient pas chapps.
#				- Correction de la doc, la variable DEBUGMODE ne PEUT PAS valoir
#					juste 0, elle doit OBLIGATOIREMENT tre une liste de 7 valeurs.
#				- Correction de l'option learn_exclusion_list qui ne fonctionnait pas
#					dans certains cas. 
#				- Ajout de la dclaration de package MegaHAL_Interface 3.1.0
#				- Suppression de l'intgration de MC.Respond
#				- Intgration de Responder (script du mme auteur  tlcharger
#					sparment)
#				- La file d'attente de parole est maintenant gre diffremment et
#					simule de faon plus raliste le temps de frappe. Auparavant, les
#					dlais de rponse taient calculs  partir d'un point de dpart
#					commun; ils sont maintenant indpendants et sont ajouts les uns 
#					la suite des autres.
#				- La commande .learnfile est maintenant plus bavarde et vous affiche
#					un message de confirmation.
#				- Correction : la casse des nicks des personnes prsentes sur le chan
#					est maintenant corrige mme si l'option substitute_all_nicks est
#					active.
#				- Correction : lors d'une lobotomie, on s'assure que le fichier BRN
#					existe bien avant d'effacer l'ancien fichier OLD.
#

#
# LICENCE:
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#

if {[info commands megahal_interface::uninstall] eq "::megahal_interface::uninstall"} { megahal_interface::uninstall }
# Note pour les programmeurs :
# Dans la version 1.6.19 d'eggdrop, le numro de version affich par .vbottree
# et [numversion] est incorrect; il affiche 1061800 ou 1061801, ce qui
# correspond  la version 1.6.18. On utilise donc une autre technique pour
# vrifier le numro de version.
if { [join [split [string range [lindex $version 0] 0 5] "."] ""] < 1619 } { putloglev o * "\00304\002\[Interface Megahal - ERREUR\]\002\003 La version de votre eggdrop est \00304\002[lindex [split $version] 0]\002\003; Interface Megahal ne fonctionnera correctement que sur les eggdrops version 1.6.19 ou suprieure." ; return }
if { [info tclversion] < 8.5 } { putloglev o * "\00304\002\[Interface MegaHAL - ERREUR\]\002\003 Interface MegaHAL ncessite que Tcl 8.5 (ou plus) soit install pour fonctionner. Votre version actuelle de Tcl est \00304\002$tcl_version\002\003." ; return }
package require Tcl 8.5
namespace eval megahal_interface {


	###########################
	#				PARAMETRES        #
	###########################

	# Notez que certaines des variables qui suivent sont dfinies dans le
	# namespace global. Ce sont des variables dclares et utilises en interne
	# par le module MegaHAL donc il est important de les laisser o elles sont.

	# Dlai en secondes aprs lequel l'I.A. sera active lors de la connexion de
	# l'eggdrop au serveur. Vous pouvez augmenter ce dlai afin de laisser le
	# temps  votre bot de passer le flood des services et les messages qu'il doit
	# envoyer au serveur en retour. Cela permet de ne pas encombrer inutilement
	# les files d'attente de l'eggdrop  un moment o elles sont dj engorges.
	# Le dlai est en secondes.
	variable IA_activation_delay 30

	# Heure de la sauvegarde quotidienne des bases de donnes.
	variable backuptime "05:15"

	# Afficher l'aide en notice ou par message priv ?
	# ( 0 = notice ; 1 = message priv )
	variable help_mode 0

	# Ce script sera-t-il utilis en conjonction avec Responder ?
	# Remarque : cette fonctionnalit ncessite Responder, script du mme auteur
	#  tlcharger sparment. Responder complte parfaitement MegaHAL en
	# ajoutant du ralisme et de la pertinence aux ractions de l'eggdrop.
	# (0 = non ; 1 = oui)
	variable use_responder 0

	# Liste des nicks/handles  ignorer dans la procdure d'apprentissage
	# (MegaHAL peut leur rpondre mais n'apprend pas).
	# Cette liste peut (et devrait) contenir les noms des autres bots, car un bot
	# qui apprend  un autre bot  parler ne donne jamais rien de bon.
	variable learn_exclusion_list {}

	# Liste des nicks/handles  qui le bot ne rpondra jamais
	# (il pourra nanmoins apprendre ce qu'ils disent)
	variable reply_exclusion_list {}

	# Mots cls auxquels le bot doit rpondre.
	# Vous pouvez par exemple y mettre le nick de l'eggdrop, ses nicks
	# alternatifs, le nom de personnes, des mots cls mots comme hello, musique,
	# etc... Vous pouvez utiliser la variable $::botnick.
	variable trigger_words {$::botnick bot eggdrop windrop}

	# Liste de mots que l'I.A. ne doit pas apprendre.
	# Si une ligne contient l'un de ces mots, toute la ligne sera exclue de
	# l'apprentissage. Vous pouvez utiliser des jokers.
	# Exemples :	*bot* matchera galement "rabotage"
	#							"* bot *" matchera le mot "bot" sauf s'il est en dbut ou en fin de phrase
	#							"bot *" matchera le mot "bot" en dbut de phrase
	#							"* bot" matchera le mot "bot" en fin de phrase
	variable learn_exclusion_wordlist {*http://* http://* *www.* www.* Tcl:*}

	# Caractres servant de prfixe aux commandes
	# (afin de permettre  l'IA d'viter d'apprendre/rutiliser des commandes)
	# remarque : pour dsactiver ce filtrage et ainsi autoriser l'IA  apprendre
	# et rutiliser des commandes ( vos risques et prils), mettez {}
	variable command_prefixes {!.}

	# Commandes pouvant tre apprises/rutilises par l'IA, spares par un espace.
	# Ces commandes pourront tre apprises et rutilises par l'IA malgr
	# le filtrage; cette rgle est prioritaire sur la variable command_prefixes
	# ci-dessus. Les jokers sont accepts. Voir les exemples fournis pour l'option
	#	learn_exclusion_wordlist concernant la bonne utilisation des jokers.
	# Exemple : variable allowed_commands {"!kick *" !randomkick}
	variable allowed_commands {}

	# Frquence  laquelle le bot va rpondre (par dfaut 3%)
	variable replyrate 3

	# Frquence  laquelle le bot va rpondre si on prononce son nom ou un mot
	# cl dfini dans trigger_words (par dfaut 90%)
	variable keyreplyrate 90

	# Frquence  laquelle le bot va apprendre (par dfaut 100%)
	variable learnrate 100

	# Nombre minimum de mots requis dans une phrase pour que MegaHAL l'apprenne
	# (Il est recommand de ne pas dfinir une valeur infrieure  $maxcontext+1,
	# voir la variable maxcontext plus bas)
	variable minlearnwords 3

	# Nombre maximum de mots dans une rponse
	# Cela peut permettre d'viter les longues phrases incohrentes interminables
	# et dnues de sens.
	# Ce paramtre force l'IA  construire des phrases plus courtes.
	# Les paramtres recommands sont environ 25-40; rglez  0 pour autoriser une
	# taille illimite.
	set ::maxreplywords 30

	# Temps maximum (en secondes) que MegaHAL s'autorise pour gnrer une rponse.
	# Il est possible de mettre des valeurs  dcimales comme par exemple 0.1
	set ::mega_timeout 1

	# Pourcentage de chances pour que le bot substitue son nick par le pseudo
	# de la personne  qui il rpond. Mettez 0 si vous ne souhaitez pas qu'il
	# fasse a.
	variable nickswitchrate 75

	# Substituer les nicks des personnes prsentes sur le chan par des symboles
	# lors de l'apprentissage, puis les substituer  nouveau par des nicks de
	# personnes prsentes sur le chan lorsqu'ils seront rutiliss par l'IA ?
	# (0 = dsactiv ; 1 = activ)
	# Cette option permet, si elle est active, de s'assurer que lorsque le bot
	# utilisera le nick de quelqu'un dans une de ses rponses, ce nick sera
	# presque toujours celui d'une des personnes prsentes  ce moment.
	# Remarque : cette option ne doit pas tre active ou dsactive selon votre
	# humeur. Le brain se construit diffremment selon comme vous l'avez rgle et
	# une lobotomie est fortement recommande chaque fois que vous la modifierez.
	variable substitute_all_nicks 1

	# Nicks  exclure de la substitution des pseudos. Cette option est lie 
	# l'option substitute_all_nicks ci-dessus et n'a de sens que si cette dernire
	# est active.
	# Les nicks lists ici ne seront pas substitus par un symbole lors de
	# l'apprentissage, et donc seront appris et rutiliss tels quels par l'I.A.
	# Ils ne seront pas non plus utiliss lors de la substitution des symboles
	# par des nicks dans les rponses du bot.
	# Notez que si vous faites des modifications dans cette liste, elles ne seront
	# pas rpercutes sur ce que l'I.A. a dj appris avant.
	# Vous pouvez utiliser la variable $::botnick
	variable nick_substitution_exclusion_list {$::botnick}

	# Sauvegarde automatique du cerveau lorsque la commande DIE est utilise ?
	# (0 = dsactiv ; 1 = activ)
	set ::mega_saveondie 1

	# Activer/dsactiver le mode debug du module MegaHAL.
	# Ce mode permet au module d'afficher des informations sur le context en cas
	# de crash mais utilise plus de mmoire.
	# (0 = dsactiv ; 1 = activ)
	set ::mega_debugmodule 0

	# Taille maximale du contexte (peut valoir de 1  5)
	# - 1 le fera bredouiller de faon incohrente la plupart du temps
	# - 2 est hautement recommand
	#	- 3 est beaucoup plus ennuyeux mais produira aussi beaucoup plus de phrases
	#		cohrentes
	# - 4 et 5 le changeront en un perroquet au lieu d'une IA rigolote
	variable maxcontext 2

	# Mode "surprise" (1 = on ; 0 = off)
	# Ce paramtre change la faon dont le bot construit ses phrases.
	# Si il est activ, l'IA essaie de trouver des combinaisons de mots
	# non-conventionnelles, ce qui signifie plus de fun mais aussi des phrases
	# plus incohrentes. S'il est dsactiv, la construction des phrases sera plus
	# sre mais l'IA ressemblera plus  un perroquet; il n'est doncrecommand de
	# le dsactiver que si la taille de l'IA est vaste, auquel cas le bot a
	# beaucoup d'options valides  utiliser.
	set ::surprise 1

	# Caractres considrs comme fin de mot
	set ::megawc_boundary " ?!:;.,()<>\[\]"

	# Caractres considrs comme sparateurs de mots et ne devant pas tre appris
	set ::megawc_space " "

	# Caractres ne devant pas tre espacs du mot qui les prcde
	set ::megawc_glue ":.,()\[\]"

	# Vitesse  laquelle le bot rpond (pour simuler le temps de frappe)
	# reply_speed_coeff = coefficient de rapidit, multiplie/divise la rapidit
	# (0.5 divise par 2 la vitesse de rfrence, etc)
	# reply_speed_offset = ajoute ou enlve des secondes au dlai
	# (pour l'affinage)
	variable reply_speed_coeff 1
	variable reply_speed_offset 0

	# Intervalle de temps minimum entre 2 apprentissages de la part d'une mme
	# personne (en secondes).
	# Remarque : ce paramtre d'viter  l'IA d'apprendre le contenu des
	# copier/coller ou le flood. Il est conseill de laisser au minimum 3 secondes
	# pour tenir compte du fakelag qui espace les lignes de 2 secondes lorsqu'on
	# copie/colle beaucoup de lignes d'un seul coup.
	variable learn_interval 5

	# Intervalle de temps minimum entre 2 rponses du bot  une mme personne
	# (en secondes)
	# Remarque : ce paramtre permet d'viter un flood de rponses de l'IA quand
	# quelqu'un fait un copier/coller de 10 lignes dont chacune contient le nom
	# de l'eggdrop par exemple.
	variable reply_interval 5

	# Protection anti-flood ( combien de lignes max par combien de secondes
	# doit-il rpondre ?)
	variable floodlimiter 4:30

	# Temps en minutes pendant lequel le bot se taira si il lui est demand de la
	# fermer galement appel mode "TAGUEULE" )
	variable shutup_time 5

	# Liste des dclencheurs du mode "TAGUEULE"
	# On choisit d'utiliser $::nick (qui est le nick par dfaut de l'eggdrop)
	# plutt que $::botnick (qui est le nick actuel de l'eggdrop) car au moment
	# o le script se charge au dmarrage de l'eggdrop, $::botnick n'est pas
	# encore renseign.
	variable shutup_triggers {
		{ta gueule $::nick} {$::nick ta gueule}
		{taggle $::nick} {$::nick taggle}
		{ta geule $::nick} {$::nick ta geule}
		{tg $::nick} {$::nick tg}
		{ferme-la $::nick} {$::nick ferme-la}
		{ferme la $::nick} {$::nick ferme la}
		{la ferme $::nick} {$::nick la ferme}
		{tu la fermes $::nick}
		{tais-toi un peu $::nick}
		{tais toi un peu $::nick}
		{tais-toi $::nick} {$::nick tais-toi}
		{tais toi $::nick} {$::nick tais toi}
		{chut $::nick} {$::nick chut}
		{a suffit $::nick} {$::nick a suffit}
		{ca suffit $::nick} {$::nick ca suffit}
		{a suffit maintenant $::nick}
		{ca suffit maintenant $::nick}
		{shutup $::nick} {$::nick shutup}
		{ftg $::nick} {$::nick ftg}
		{stfu $::nick} {$::nick stfu}
		{couch $::nick} {$::nick couch}
		{$::nick ! couch} {va coucher $::nick}
		{$::nick  la niche} {$::nick a la niche}
		{la niche $::nick}
	}

	# Taille maximale de la file d'attente des rponses.
	# Tant que le nombre de rponses contenues dans la file d'attente est
	# suprieur ou gal  cette valeur, MegaHAL n'autorise pas l'ajout de
	# nouvelles rponses provenant de l'IA.
	# Sachez nanmoins si vous utilisez conjointement Responder, qu'il est
	# prioritaire et est autoris  ajouter de nouvelles rponses quelle que soit
	# la taille de la file d'attente.
	variable max_talk_queue 3

	# Taille maximum de l'IA (en nombre de nodes)
	# Cette valeur influe sur la taille du cerveau, donc sur la place qu'il
	# occupe en RAM ainsi que sur le disque dur.
	# Estimation trs approximative : 50000 nodes = 1Mo
	# Ne soyez pas trop radin si vous voulez voir votre bot s'panouir.
	set ::maxsize 1000000

	# Le bot peut ajouter une 2me rponse neutre avant ou aprs la rponse
	# principale de MegaHAL (si il rpond).
	# Ajouter alatoirement une 2me rponse neutre avant OU aprs la rponse
	# principale ? (0 = non ; 1 = oui)
	variable 2nd_neutral_reply 1

	# Quel pourcentage de chances pour qu'il y ait une 2me rponse neutre ?
	variable 2nd_neutral_reply_rate 10

	# - Si la 2me rponse neutre a lieu AVANT la rponse principale,
	# cette option reprsente le dlai {min max} entre le dclencheur et la
	# rponse neutre.
	# - Si la 2me rponse neutre a lieu APRES la rponse principale,
	# cette option reprsente le dlai {min max} entre la rponse principale
	# et la rponse neutre.
	# Les dlais sont exprims en secondes.
	variable 2nd_neutral_reply_delay {2 5}

	# Rponses neutres possibles  placer avant la rponse principale.
	# Si vous souhaitez utiliser les caractres \ { } vous devez les antislasher
	# comme ceci : \\ \{ \}
	# Vous pouvez utiliser les variables $nick $chan et $hand dans les rponses.
	variable 2nd_neutral_pre_reply_list {
		{nawak} {n'importe quoi} {ou ou} {ouais c'est a ouais} {ben voyons}
		{gn ?} {huh ?} {ou pas} {bref} {mmh ?} {euh..} {ou} {erf} {+1} {lol}
		{mdr} {?} {huh} {uh ?} {oups} {:]} {:} {:o} {bizarre} {tiens ?} {><}
		{bah} {mw} {mouais} {voil} {hein ?} {hh} {et ?} {osef} {on s'en fout}
	}

	# Rponses neutres possibles  placer aprs la rponse principale.
	# Si vous souhaitez utiliser les caractres \ { } vous devez les antislasher
	# comme ceci : \\ \{ \}
	# Vous pouvez utiliser les variables $nick $chan et $hand dans les rponses.
	variable 2nd_neutral_post_reply_list {
		{enfin moi ce que j'en dis} {hum mauvaise fentre} {oups mauvais chan}
		{a a un sens ce que je viens de dire ?} {ou alors j'ai rien compris}
		{non ?} {ou pas} {bref} {mmh ?} {euh..} {ou} {erf} {lol} {mdr} {?} {huh}
		{uh ?} {oups} {:]} {:} {:o} {><} {bah} {mw} {voil} {hein ?} {hh}
		{enfin moi c'que j'en dis} {un truc de dingue} {bizarre}
	}

	# Activer les couleurs dans les messages de l'interface ? (0 = non ; 1 = oui)
	set ::mega_colormode 1

	# Couleur principale dans les messages de l'interface
	set ::mega_color1 14

	# Couleur secondaire dans les messages de l'interface
	set ::mega_color2 07

	### Commandes et autorisations
	#
	# commande publique pour afficher la liste des commandes spcifiques  MegaHAL
	variable help_cmd ".aide_megahal"
	variable help_auth "-|-"
	# commande publique pour activer/dsactiver l'I.A. sur un chan
	variable masterswitch_cmd ".megahal"
	variable masterswitch_auth "n|n"
	# commande publique pour activer/dsactiver l'apprentissage sur un chan
	variable learnstate_cmd	".learn"
	variable learnstate_auth "n|n"
	# commande publique pour activer/dsactiver la rponse de l'I.A. en cas de mot
	# cl dtect
	variable respondstate_cmd ".respond"
	variable respondstate_auth "n|n"
	# commande publique pour activer/dsactiver la libre expression
	variable chatterstate_cmd ".chatter"
	variable chatterstate_auth "n|n"
	# commande publique pour afficher/modifier le taux de rponse libre
	variable replyrate_cmd ".replyrate"
	variable replyrate_auth "m|m"
	# commande publique pour afficher/modifier le taux de rponse en cas de mot
	# cl dtect
	variable keyreplyrate_cmd ".keyreplyrate"
	variable keyreplyrate_auth "m|m"
	# commande publique pour demander  l'I.A. d'oublier une phrase
	variable forget_cmd ".forget"
	variable forget_auth "n|n"
	# commande publique pour demander  l'I.A. d'oublier un mot
	variable forgetword_cmd ".forgetword"
	variable forgetword_auth "n|n"
	# commande publique pour vrifier si l'I.A. connait une phrase donne
	variable seekstatement_cmd ".seekstatement"
	variable seekstatement_auth "m|m"
	# commande publique pour vrifier si l'I.A. connait un mot donn et en compter
	# toutes les occurrences
	variable countword_cmd ".countword"
	variable countword_auth "m|m"
	# commande publique pour demander  l'I.A. d'apprendre le contenu d'un fichier
	variable learnfile_cmd ".learnfile"
	variable learnfile_auth "n|n"
	# commande publique pour sauvegarder le cerveau
	variable savebrain_cmd ".savebrain"
	variable savebrain_auth "m|m"
	# commande publique pour recharger le cerveau
	variable reloadbrain_cmd ".reloadbrain"
	variable reloadbrain_auth "n|n"
	# commande publique pour recharger les phrases (depuis le fichier .phr)
	variable reloadphrases_cmd ".reloadphrases"
	variable reloadphrases_auth "n|n"
	# commande publique pour effectuer un lagage du cerveau
	variable trimbrain_cmd ".trimbrain"
	variable trimbrain_auth "n|n"
	# commande publique pour effectuer un lavage de cerveau
	variable lobotomy_cmd ".lobotomy"
	variable lobotomy_auth "n|n"
	# commande publique pour restaurer un backup du cerveau
	variable restorebrain_cmd ".restorebrain"
	variable restorebrain_auth "n|n"
	# commande publique pour afficher le statut de l'I.A. sur le chan en cours
	variable chanstatus_cmd ".megahal_status"
	variable chanstatus_auth "m|m"
	# commande publique pour afficher des informations sur l'I.A.
	variable braininfo_cmd ".braininfo"
	variable braininfo_auth "-|-"
	# commande publique pour afficher une estimation de la quantit de mmoire
	# utilise par l'I.A.
	variable memusage_cmd ".memusage"
	variable memusage_auth "-|-"
	# commande publique pour afficher la taille d'une arborescence
	variable treesize_cmd ".treesize"
	variable treesize_auth "m|m"
	# commande publique pour afficher le contenu d'une branche de l'arborescence
	variable viewbranch_cmd ".viewbranch"
	variable viewbranch_auth "m|m"
	# prfixe  mettre en dbut de phrase pour forcer l'I.A.  apprendre + rpondre
	variable force_L_R_cmd "&"
	variable force_L_R_auth "m|m"
	# prfixe  mettre en dbut de phrase pour forcer l'I.A.  ne pas apprendre + rpondre
	variable force_noL_R_cmd "%"
	variable force_noL_R_auth "m|o"
	# prfixe  mettre en dbut de phrase pour forcer l'I.A.  apprendre + ne pas rpondre
	variable force_L_noR_cmd "~"
	variable force_L_noR_auth "m|m"
	# prfixe  mettre en dbut de phrase pour forcer l'I.A.  ne pas apprendre + ne pas rpondre
	variable force_noL_noR_cmd "$"
	variable force_noL_noR_auth "m|o"

	# DEBUGMODE vous permet d'activer le mode dboguage et d'afficher tout un tas
	# d'informations en partyline sur le fonctionnement interne de l'Interface
	# MegaHAL. Si vous activez tous les niveaux de dbogage en mme temps, cela
	# gnrera un flood important dans la partyline de l'eggdrop.
	# Si vous n'tes pas dveloppeur ou pas curieux, vous pouvez ignorer cette
	# option.
	# DEBUGMODE est une liste de 7 valeurs boolennes. Chacune de ces valeurs peut
	# donc valoir 0 (dsactiv) ou 1 (activ).
	# Voici dans l'ordre leur signification :
	#		- appels de procdures + dump des arguments envoys
	#		- phase d'apprentissage
	#		- phase de rponse
	#		- suivi des corrections effectues par la moulinette d'apprentissage/soumission
	#		- suivi des corrections effectues par la moulinette de rponse
	#		- activation / dsactivation du mode "TAGUEULE"
	#		- surveillance de l'anti-flood
	# Exemples :
	#		variable DEBUGMODE {0 0 0 0 0 0 0}
	#			-> 	aucune information de dboguage ne sera affiche
	#		variable DEBUGMODE {0 1 0 1 0 0 0}
	#			-> 	les informations suivantes seront affiches en partyline :
	#					phase d'apprentissage / suivi des corrections effectues par la
	#					moulinette d'apprentissage
	variable DEBUGMODE {0 0 0 0 0 1 0}

	# Afin de ne pas tre flood par les lignes de debug au cas o l'eggdrop
	# se trouve sur de nombreux chans frquents, le mode debug peut restreindre
	# sa surveillance  un seul chan que vous dfinissez ici.
	# Veillez  respecter la casse des caractres de votre chan.
	# Si vous souhaitez malgr tout activer le mode debug sur tous les chans en
	# mme temps, mettez "*"
	variable DEBUGMODE_chan "*"




	###################################
	# Fin de la section configuration #
	###################################

	package provide MegaHAL_Interface 3.1.0
	variable version "3.1.0.20101226"
	variable scriptname "Interface MegaHAL"
	variable instance ; array set instance {}
	variable shutup ; array set shutup {}
	variable floodlock_learn ; array set floodlock_learn {}
	variable floodlock_reply ; array set floodlock_reply {}
	variable backuptime [split $backuptime ":"]
	variable talk_queue ""
	variable delayed_talk_running 0
	variable check_responder 0
	setmegabotnick $::nick
	setmaxcontext $maxcontext
	set ::mega_minLearnWords $minlearnwords
	# on dsactive l'apprentissage conventionnel du module MegaHAL car l'interface
	# MegaHAL contrle cet aspect par ses propres moyens.
	learningmode off
	# on enlve les binds que le module MegaHAL a install afin de pouvoir
	# mettre les ntres
	set binds_list [binds]
	if { [lsearch -regexp $binds_list {pubm -\|- \* [0-9]+ \*pubm:mega}] != -1 } { unbind pubm -|- * *pubm:mega }
	if { [lsearch -regexp $binds_list {ctcp -\|- ACTION [0-9]+ \*ctcp:mega}] != -1 } { unbind ctcp -|- ACTION *ctcp:mega }
	if { [lsearch -regexp $binds_list {pub - hal: [0-9]+ \*pub:hal:}] != -1 } { unbind pub - hal: *pub:hal: }
	if { [lsearch -regexp $binds_list {dcc - hal [0-9]+ \*dcc:hal}] != -1 } { unbind dcc - hal *dcc:hal }
	if { [lsearch -regexp $binds_list {pub -\|- .megaver [0-9]+ \*pub:.megaver}] != -1 } { unbind pub -|- .megaver *pub:.megaver }
	if { [lsearch -regexp $binds_list {pub n\|n .forget [0-9]+ \*pub:.forget}] != -1 } { unbind pub n|n .forget *pub:.forget }
	if { [lsearch -regexp $binds_list {pub n\|n .forgetword [0-9]+ \*pub:.forgetword}] != -1 } { unbind pub n|n .forgetword *pub:.forgetword }
	if { [lsearch -regexp $binds_list {pub m\|m .megaseek [0-9]+ \*pub:.megaseek}] != -1 } { unbind pub m|m .megaseek *pub:.megaseek }
	if { [lsearch -regexp $binds_list {pub m\|m .megacount [0-9]+ \*pub:.megacount}] != -1 } { unbind pub m|m .megacount *pub:.megacount }
	unset binds_list
	setudef flag megahal
	setudef flag megahal_learn
	setudef flag megahal_respond
	setudef flag megahal_chatter
	# construction d'une liste qui sera utilise par le string map du mode "TAGUEULE"
	variable shutup_trigger_list
	foreach trigger $shutup_triggers {
		lappend shutup_trigger_list [subst $trigger] "!-shutup-!"
	}
	variable floodlimiter [split $floodlimiter ":"]
	# Procdure de dsinstallation
	# (le script se dsinstalle totalement avant chaque rehash ou  chaque relecture au moyen de la commande "source" ou autre)
	proc uninstall {args} {
		putlog "Dsallocation des ressources de \002$megahal_interface::scriptname\002..."
		foreach binding [lsearch -inline -all -regexp [binds *[set ns [string range [namespace current] 2 end]]*] " \{?(::)?$ns"] {
			unbind [lindex $binding 0] [lindex $binding 1] [lindex $binding 2] [lindex $binding 4]
		}
		foreach running_timer [timers] {
			if { [string match "*[namespace current]::*" [lindex $running_timer 1]] } { killtimer [lindex $running_timer 2] }
		}
		foreach running_utimer [utimers] {
			if { [string match "*[namespace current]::*" [lindex $running_utimer 1]] } { killutimer [lindex $running_utimer 2] }
		}
		package forget MegaHAL_Interface
		namespace delete ::megahal_interface
	}
}

###
### Traitement des donnes reues
###
proc megahal_interface::process {nick host hand chan text} {
	if { ![channel get $chan megahal] } { return }
	if { (($megahal_interface::DEBUGMODE_chan eq "*") || ($chan eq $megahal_interface::DEBUGMODE_chan)) && ([lindex $megahal_interface::DEBUGMODE 0]) } {
		putlog "\00304\[MEGAHAL DEBUG\]\003 \00306i!i\003\00313!i!\003\00314 dump \003process\00314 : $nick | $host | $hand | $chan | $text\003"
	}
	set clean_chan [megahal_interface::neutralize_special_chars $chan]
	set clean_nick [megahal_interface::neutralize_special_chars $nick]
	set text [megahal_interface::strip_codes_trim_spaces $text]
	if { [megahal_interface::is_learn_allowed_1st_pass $nick $clean_nick $host $hand $chan $clean_chan $text] } {
		set unmodified_text_to_learn [regsub "^(\\$megahal_interface::force_L_R_cmd|\\$megahal_interface::force_noL_R_cmd|\\$megahal_interface::force_L_noR_cmd|\\$megahal_interface::force_noL_noR_cmd)" $text ""]
		set text_to_learn [string trim [megahal_interface::moulinex_in learn $nick $chan $unmodified_text_to_learn]]
		if { ![megahal_interface::is_learn_allowed_2nd_pass $nick $host $hand $chan $text $text_to_learn] } {
			unset text_to_learn
			unset unmodified_text_to_learn
		}
	}
	# remarque : on n'apprend pas tout de suite afin de ne pas risquer de retrouver le contenu de la requte dans la rponse
	if { [megahal_interface::is_talk_allowed_1st_pass $nick $clean_nick $host $hand $chan $clean_chan $text] } {
		if { $megahal_interface::use_responder } {
			# on dfinit  0 la variable de test permettant de savoir si Responder a rpondu ou pas
			variable check_responder 0
			# on appelle Responder pour voir s'il a quelque chose  dire
			::responder::process $nick $host $hand $chan $text
			# si Responder a rpondu  $nick, on le note pour l'antiflood
			if { $::megahal_interface::check_responder } {
				megahal_interface::flood $chan add_instance
				variable floodlock_reply
				set floodlock_reply($clean_chan,$clean_nick) 1
				after [expr $megahal_interface::reply_interval * 1000] "megahal_interface::unfloodlock_reply $clean_chan $clean_nick"
			}
		}
		# on dtecte s'il est demand au bot de se taire
		if { [string match -nocase "*!-shutup-!*" [string map -nocase $megahal_interface::shutup_trigger_list $text]] == 1 } {
			variable shutup
			set shutup($clean_chan) 1
			after [expr $megahal_interface::shutup_time * 60000] "megahal_interface::unshutup $clean_chan"
			if { (($megahal_interface::DEBUGMODE_chan eq "*") || ($chan eq $megahal_interface::DEBUGMODE_chan)) && ([lindex $megahal_interface::DEBUGMODE 5]) } {
				putlog "\00304\[MEGAHAL\] \002Mode TAGUEULE activ pour $megahal_interface::shutup_time minutes sur $chan\002\003"
			}
			set do_2nd_pass 0
		} else { set do_2nd_pass 1 }
		if { ($do_2nd_pass) && ([megahal_interface::is_talk_allowed_2nd_pass $nick $host $hand $chan $text]) } {
			if { ![info exists text_to_learn] } {
				set submitted_text [megahal_interface::moulinex_in submit $nick $chan [set unmodified_text_to_get_reply_from [regsub "^(\\$megahal_interface::force_L_R_cmd|\\$megahal_interface::force_noL_R_cmd|\\$megahal_interface::force_L_noR_cmd|\\$megahal_interface::force_noL_noR_cmd)" $text ""]]]
				set is_modified_getreply 1
			} else {
				set submitted_text $text_to_learn
				set is_modified_getreply 0
			}
			if { (($megahal_interface::DEBUGMODE_chan eq "*") || ($chan eq $megahal_interface::DEBUGMODE_chan)) && ($is_modified_getreply) && ([lindex $megahal_interface::DEBUGMODE 3]) && ([string compare -nocase [string map {"." ""} $submitted_text] [string map {"." ""} $unmodified_text_to_get_reply_from]] != 0) } {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00307\[$chan\]\003 \00314 $unmodified_text_to_get_reply_from\003"
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00312--getreply-->\003\00315 $submitted_text\003"
			}
			set reply [megahal_interface::moulinex_out $nick $chan [string tolower [::megahal_getreply $submitted_text]]]
			if { [megahal_interface::is_talk_allowed_3rd_pass $nick $host $hand $chan $reply] } {
				megahal_interface::flood $chan add_instance
				megahal_interface::talk $chan $clean_chan $nick $clean_nick "internal" $reply
			} elseif { (($megahal_interface::DEBUGMODE_chan eq "*") || ($chan eq $megahal_interface::DEBUGMODE_chan)) && ([lindex $megahal_interface::DEBUGMODE 2]) } {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00305i!i\003\00304!i!\003\00314 la rponse contient une commande ne faisant pas partie des commandes autorises ( \00307[lindex [split $reply] 0]\00314 )\003"
			}				
		}
	}
	if { [info exists text_to_learn] } {
	if { (($megahal_interface::DEBUGMODE_chan eq "*") || ($chan eq $megahal_interface::DEBUGMODE_chan)) && ([lindex $megahal_interface::DEBUGMODE 3]) && ([string compare -nocase [string map {"." ""} $text_to_learn] [string map {"." ""} $unmodified_text_to_learn]] != 0) } {
		putlog "\00304\[MEGAHAL DEBUG\]\003 \00307\[$chan\]\003 \00314 $unmodified_text_to_learn\003"
		putlog "\00304\[MEGAHAL DEBUG\]\003 \00303--learn-->\003\00315 $text_to_learn\003"
	}
		megahal_interface::learn $nick $clean_nick $chan $clean_chan $text_to_learn
	}
}

###
### Autorisation d'apprendre ? (1re passe)
### (retourne 1 pour oui, 0 pour non)
###
proc megahal_interface::is_learn_allowed_1st_pass {nick clean_nick host hand chan clean_chan text} {
	variable floodlock_learn
	if { ![info exists megahal_interface::floodlock_learn($clean_chan,$clean_nick)] } { set floodlock_learn($clean_chan,$clean_nick) 0 }
	set coin [rand 101]
	if { $megahal_interface::learn_exclusion_wordlist ne "" } {
		set forbidden_word ""
		foreach word $megahal_interface::learn_exclusion_wordlist {
			if { [string match -nocase $word $text] } { set forbidden_word $word }
		}
	}
	# ---------------------------------------------------------------------------
	if { (($megahal_interface::DEBUGMODE_chan eq "*") || ($chan eq $megahal_interface::DEBUGMODE_chan)) && ($megahal_interface::DEBUGMODE != 0) } {
		if { ([lindex $megahal_interface::DEBUGMODE 0]) || ([lindex $megahal_interface::DEBUGMODE 1]) || ([lindex $megahal_interface::DEBUGMODE 2]) } {
			putlog "\00304\[MEGAHAL DEBUG\]\003 \00307i!i\003\00308!i!i!i!\003\00314 \002$chan\002 <$nick> $text\003"
		}
		if { [lindex $megahal_interface::DEBUGMODE 0] } {
			putlog "\00304\[MEGAHAL DEBUG\]\003 \00306i!i\003\00313!i!\003\00314 dump \003is_learn_allowed_1st_pass\00314 : $nick | $clean_nick | $host | $hand ([chattr $hand $chan]) | $chan | $clean_chan | $text\003"
		}
		if { [lindex $megahal_interface::DEBUGMODE 1] } {
			putlog "\00304\[MEGAHAL DEBUG\]\003 \00310i!i\003\00311!i!\003\00314 ENUMERATION DES CRITERES D'APPRENTISSAGE (1ERE PASSE)\003"
			if { [channel get $chan megahal_learn] } {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00303i!i\003\00309!i!\003\00314 L'apprentissage est actif sur $chan (flag +megahal_learn).\003"
			} else {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00305i!i\003\00304!i!\003\00314 L'apprentissage est inactif sur $chan (flag -megahal_learn).\003"
			}
			if { [string match "$megahal_interface::force_L_R_cmd*" $text] } {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00303i!i\003\00309!i!\003\00314 la ligne commence par \"$megahal_interface::force_L_R_cmd\" : \003\00303\002apprentissage forc\002\003\00314 + rponse force si flags \003\00307$megahal_interface::force_L_R_auth\003"
			} elseif { [string match "$megahal_interface::force_L_noR_cmd*" $text] } {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00303i!i\003\00309!i!\003\00314 la ligne commence par \"$megahal_interface::force_L_noR_cmd\" : \003\00303\002apprentissage forc\002\003\00314 + ne rpond pas si flags \003\00307$megahal_interface::force_L_noR_auth\003"
			}
			if { ([lsearch -nocase $megahal_interface::learn_exclusion_list $nick] != -1) || ([lsearch -nocase -exact $megahal_interface::learn_exclusion_list $hand] != -1) } { 
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00305i!i\003\00304!i!\003\00314 \002$nick\002/\002$hand\002 est prsent dans la liste \$learn_exclusion_list (\00307$megahal_interface::learn_exclusion_list\003\00314)\003"
			} else {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00303i!i\003\00309!i!\003\00314 \002$nick\002/\002$hand\002 n'est pas prsent dans la liste \$learn_exclusion_list\003"
			}
			if { $megahal_interface::learn_exclusion_wordlist ne "" } {
				if { $forbidden_word ne "" } { 
					putlog "\00304\[MEGAHAL DEBUG\]\003 \00305i!i\003\00304!i!\003\00314 au moins un mot figure dans la liste des mots dont l'apprentissage est interdit (\00307$forbidden_word\003\00314)\003"
				} else {
					putlog "\00304\[MEGAHAL DEBUG\]\003 \00303i!i\003\00309!i!\003\00314 aucun mot ne figure dans la liste des mots dont l'apprentissage est interdit\003"
				}
			}
			if { !$megahal_interface::floodlock_learn($clean_chan,$clean_nick) } {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00303i!i\003\00309!i!\003\00314 Le mode \"floodlock_learn\" n'est pas actif pour $nick sur $chan\003"
			} else {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00305i!i\003\00304!i!\003\00314 Le mode \"floodlock_learn\" est actif pour $nick sur $chan\003"
			}
			putlog "\00304\[MEGAHAL DEBUG\]\003 \00314i!i\003\00315!i!\003\00314 tirage d'un nombre alatoire entre 1 et 100 afin de dterminer si le bot a le droit d'apprendre : \003\00307$coin\003"
			if { [set num_words [llength [split $text]]] >= $megahal_interface::minlearnwords } {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00303i!i\003\00309!i!\003\00314 La phrase a une longueur suprieure ou gale  \$minlearnwords (\003\00307$num_words \003\00314>=\003\00307 $megahal_interface::minlearnwords\003\00314)\003"
			} else {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00305i!i\003\00304!i!\003\00314 La phrase a une longueur infrieure  \$minlearnwords (\003\00307$num_words \003\00314<\003\00307 $megahal_interface::minlearnwords\003\00314)\003"
			}
			if { $coin <= $megahal_interface::learnrate } {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00303i!i\003\00309!i!\003\00314 le bot a \003\00307$megahal_interface::learnrate%\003\00314 de chances d'apprendre.\003"
			} else {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00305i!i\003\00304!i!\003\00314 le bot a \003\00307$megahal_interface::learnrate%\003\00314 de chances d'apprendre.\003"
			}
			if { [string match "$megahal_interface::force_noL_R_cmd*" $text] } {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00305i!i\003\00304!i!\003\00314 la ligne commence par \"$megahal_interface::force_noL_R_cmd\" : n'apprend pas + rponse force si flags \003\00307$megahal_interface::force_noL_R_auth\003"
			} elseif { [string match "$megahal_interface::force_noL_noR_cmd*" $text] } {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00305i!i\003\00304!i!\003\00314 la ligne commence par \"$megahal_interface::force_noL_noR_cmd\" : n'apprend pas + ne rpond pas si flags \003\00307$megahal_interface::force_noL_noR_auth\003"
			}
			if { ![megahal_interface::handle_command $text] } {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00305i!i\003\00304!i!\003\00314 la ligne est une commande ne faisant pas partie des commandes autorises ( \00307$text\00314 )\003"
			} else {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00303i!i\003\00309!i!\003\00314 la ligne n'est pas une commande ou fait partie des commandes autorises.\003"
			}
		}
	}
	# ---------------------------------------------------------------------------
	if { ([channel get $chan megahal_learn])\
	 && (((([string match "$megahal_interface::force_L_R_cmd*" $text]) && ([matchattr $hand $megahal_interface::force_L_R_auth $chan]))\
	 || (([string match "$megahal_interface::force_L_noR_cmd*" $text]) && ([matchattr $hand $megahal_interface::force_L_noR_auth $chan])))\
	 || (([lsearch -nocase $megahal_interface::learn_exclusion_list $nick] == -1)\
	 && ([lsearch -nocase -exact $megahal_interface::learn_exclusion_list $hand] == -1)\
	 && ($forbidden_word eq "")\
	 && (!$megahal_interface::floodlock_learn($clean_chan,$clean_nick))\
	 && ([llength [split $text]] >= $megahal_interface::minlearnwords)\
	 && ($coin <= $megahal_interface::learnrate)\
	 && !(([string match "$megahal_interface::force_noL_R_cmd*" $text]) && ([matchattr $hand $megahal_interface::force_noL_R_auth $chan]))\
	 && !(([string match "$megahal_interface::force_noL_noR_cmd*" $text]) && ([matchattr $hand $megahal_interface::force_noL_noR_auth $chan]))\
	 && ([megahal_interface::handle_command $text]))) } {

if { $chan eq "#testchan" } { putlog "\00303autoris  apprendre" }

		return 1
	} else {
		if { (($megahal_interface::DEBUGMODE_chan eq "*") || ($chan eq $megahal_interface::DEBUGMODE_chan)) && ([lindex $megahal_interface::DEBUGMODE 1]) } {
			putlog "\00304\[MEGAHAL DEBUG\]\003 \002\00305i!i\003\00304!i!\003\002\00314 L'apprentissage n'a pas t autoris aprs passage en revue des critres.\003"
		}

if { $chan eq "#testchan" } { putlog "\00304pas autoris  apprendre" }

		return 0
	}
}

###
### Autorisation d'apprendre ? (2me passe : on vrifie qu'aprs le passage de
### la moulinette, la ligne ne commence pas par une commande et est encore assez
### longue pour tre apprise)
### (retourne 1 pour oui, 0 pour non)
###
proc megahal_interface::is_learn_allowed_2nd_pass {nick host hand chan text text_to_learn} {
	# ---------------------------------------------------------------------------
	if { (($megahal_interface::DEBUGMODE_chan eq "*") || ($chan eq $megahal_interface::DEBUGMODE_chan)) && ($megahal_interface::DEBUGMODE != 0) } {
		if { [lindex $megahal_interface::DEBUGMODE 0] } {
			putlog "\00304\[MEGAHAL DEBUG\]\003 \00306i!i\003\00313!i!\003\00314 dump \003is_learn_allowed_2nd_pass\00314 : $nick | $host | $hand ([chattr $hand $chan]) | $chan | $text | $text_to_learn\003"
		}
		if { [lindex $megahal_interface::DEBUGMODE 1] } {
			putlog "\00304\[MEGAHAL DEBUG\]\003 \00310i!i\003\00311!i!\003\00314 ENUMERATION DES CRITERES D'APPRENTISSAGE (2EME PASSE)\003"
			if { [string match "$megahal_interface::force_L_R_cmd*" $text] } {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00303i!i\003\00309!i!\003\00314 la ligne commence par \"$megahal_interface::force_L_R_cmd\" : \003\00303\002apprentissage forc\002\003\00314 + rponse force si flags \003\00307$megahal_interface::force_L_R_auth\003"
			} elseif { [string match "$megahal_interface::force_L_noR_cmd*" $text] } {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00303i!i\003\00309!i!\003\00314 la ligne commence par \"$megahal_interface::force_L_noR_cmd\" : \003\00303\002apprentissage forc\002\003\00314 + ne rpond pas si flags \003\00307$megahal_interface::force_L_noR_auth\003"
			}
			if { [set num_words [llength [split $text_to_learn]]] >= $megahal_interface::minlearnwords } {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00303i!i\003\00309!i!\003\00314 La phrase a une longueur suprieure ou gale  \$minlearnwords (\003\00307$num_words \003\00314>=\003\00307 $megahal_interface::minlearnwords\003\00314)\003"
			} else {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00305i!i\003\00304!i!\003\00314 La phrase a une longueur infrieure  \$minlearnwords (\003\00307$num_words \003\00314<\003\00307 $megahal_interface::minlearnwords\003\00314)\003"
			}
			if { ![megahal_interface::handle_command $text_to_learn] } {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00305i!i\003\00304!i!\003\00314 la ligne est une commande ne faisant pas partie des commandes autorises ( \00307$text_to_learn\00314 )\003"
			} else {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00303i!i\003\00309!i!\003\00314 la ligne n'est pas une commande ou fait partie des commandes autorises.\003"
			}
		}
	}
	# ---------------------------------------------------------------------------
	if { (([string match "$megahal_interface::force_L_R_cmd*" $text]) && ([matchattr $hand $megahal_interface::force_L_R_auth $chan]))\
	 || (([string match "$megahal_interface::force_L_noR_cmd*" $text]) && ([matchattr $hand $megahal_interface::force_L_noR_auth $chan]))\
	 || (([llength [split $text_to_learn]] >= $megahal_interface::minlearnwords)\
	 && ([megahal_interface::handle_command $text_to_learn])) } {
		return 1
	} else {
		if { (($megahal_interface::DEBUGMODE_chan eq "*") || ($chan eq $megahal_interface::DEBUGMODE_chan)) && ([lindex $megahal_interface::DEBUGMODE 1]) } {
			putlog "\00304\[MEGAHAL DEBUG\]\003 \002\00305i!i\003\00304!i!\003\002\00314 L'apprentissage n'a pas t autoris aprs passage en revue des critres.\003"
		}
		return 0
	}
}

###
### Autorisation de rpondre ? (1re passe : avant appel de Responder)
### (retourne 1 pour oui, 0 pour non)
###
proc megahal_interface::is_talk_allowed_1st_pass {nick clean_nick host hand chan clean_chan text} {
	variable shutup
	variable floodlock_reply
	if { ![info exists megahal_interface::shutup($clean_chan)] } { set shutup($clean_chan) 0 }
	if { ![info exists megahal_interface::floodlock_reply($clean_chan,$clean_nick)] } { set floodlock_reply($clean_chan,$clean_nick) 0 }
	# ---------------------------------------------------------------------------
	if { (($megahal_interface::DEBUGMODE_chan eq "*") || ($chan eq $megahal_interface::DEBUGMODE_chan)) && ($megahal_interface::DEBUGMODE != 0) } {
		if { [lindex $megahal_interface::DEBUGMODE 0] } {
			putlog "\00304\[MEGAHAL DEBUG\]\003 \00306i!i\003\00313!i!\003\00314 dump \003is_talk_allowed_1st_pass\00314 : $nick | $clean_nick | $host | $hand ([chattr $hand $chan]) | $chan | $clean_chan | $text\003"
		}
		if { [lindex $megahal_interface::DEBUGMODE 2] } {
			putlog "\00304\[MEGAHAL DEBUG\]\003 \00310i!i\003\00311!i!\003\00314 ENUMERATION DES CRITERES DE REPONSE (1ERE PASSE)\003"
			if { [string match "$megahal_interface::force_L_R_cmd*" $text] } {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00303i!i\003\00309!i!\003\00314 la ligne commence par \"$megahal_interface::force_L_R_cmd\" : apprentissage forc + \003\00303\002rponse force\002\003\00314 si flags \003\00307$megahal_interface::force_L_R_auth\003"
			} elseif { [string match "$megahal_interface::force_noL_R_cmd*" $text] } {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00303i!i\003\00309!i!\003\00314 la ligne commence par \"$megahal_interface::force_noL_R_cmd\" : n'apprend pas + \003\00303\002rponse force\002\003\00314 si flags \003\00307$megahal_interface::force_noL_R_auth\003"
			} elseif { [string match "$megahal_interface::force_L_noR_cmd*" $text] } {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00305i!i\003\00304!i!\003\00314 la ligne commence par \"$megahal_interface::force_L_noR_cmd\" : apprentissage forc + ne rpond pas si flags \003\00307$megahal_interface::force_L_noR_auth\003"
			} elseif { [string match "$megahal_interface::force_noL_noR_cmd*" $text] } {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00305i!i\003\00304!i!\003\00314 la ligne commence par \"$megahal_interface::force_noL_noR_cmd\" : n'apprend pas + ne rpond pas si flags \003\00307$megahal_interface::force_noL_noR_auth\003"
			}
			if { ([lsearch -nocase $megahal_interface::reply_exclusion_list $nick] != -1) || ([lsearch -nocase -exact $megahal_interface::reply_exclusion_list $hand] != -1) } {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00305i!i\003\00304!i!\003\00314 \002$nick\002/\002$hand\002 est prsent dans la liste \$reply_exclusion_list (\00307$megahal_interface::reply_exclusion_list\003\00314)\003"
			} else {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00303i!i\003\00309!i!\003\00314 \002$nick\002/\002$hand\002 n'est pas prsent dans la liste \$reply_exclusion_list\003"
			}
			if { !$megahal_interface::shutup($clean_chan) } {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00303i!i\003\00309!i!\003\00314 Le mode \"ta gueule\" n'est pas actif sur $chan\003"
			} else {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00305i!i\003\00304!i!\003\00314 Le mode \"ta gueule\" est actif sur $chan\003"
			}
			if { !$megahal_interface::floodlock_reply($clean_chan,$clean_nick) } {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00303i!i\003\00309!i!\003\00314 Le mode \"floodlock_reply\" n'est pas actif pour $nick sur $chan\003"
			} else {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00305i!i\003\00304!i!\003\00314 Le mode \"floodlock_reply\" est actif pour $nick sur $chan\003"
			}
			if { ![megahal_interface::flood $chan check] } {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00303i!i\003\00309!i!\003\00314 L'antiflood n'a pas t dclench sur $chan\003"
			} else {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00305i!i\003\00304!i!\003\00314 L'antiflood a t dclench sur $chan\003"
			}
		}
	}
	# ---------------------------------------------------------------------------
	if { ((([string match "$megahal_interface::force_L_R_cmd*" $text]) && ([matchattr $hand $megahal_interface::force_L_R_auth $chan]))\
	 || (([string match "$megahal_interface::force_noL_R_cmd*" $text]) && ([matchattr $hand $megahal_interface::force_noL_R_auth $chan])))\
	 || ((([lsearch -nocase $megahal_interface::reply_exclusion_list $nick] == -1)\
	 || ([lsearch -nocase -exact $megahal_interface::reply_exclusion_list $hand] == -1))\
	 && (!$megahal_interface::shutup($clean_chan))\
	 && (!$megahal_interface::floodlock_reply($clean_chan,$clean_nick))\
	 && (![megahal_interface::flood $chan check])\
	 && !(([string match "$megahal_interface::force_L_noR_cmd*" $text]) && ([matchattr $hand $megahal_interface::force_L_noR_auth $chan]))\
	 && !(([string match "$megahal_interface::force_noL_noR_cmd*" $text]) && ([matchattr $hand $megahal_interface::force_noL_noR_auth $chan]))) } {
		return 1
	} else {
		if { (($megahal_interface::DEBUGMODE_chan eq "*") || ($chan eq $megahal_interface::DEBUGMODE_chan)) && ([lindex $megahal_interface::DEBUGMODE 2]) } {
			putlog "\00304\[MEGAHAL DEBUG\]\003 \002\00305i!i\003\00304!i!\003\002\00314 La parole n'a pas t autorise aprs passage en revue des critres.\003"
		}
		return 0
	}
}

###
### Autorisation de rpondre ? (2me passe : aprs appel de Responder et
### vrification que le mode TAGUEULE n'a pas t dclench)
### (retourne 1 pour oui, 0 pour non)
###
proc megahal_interface::is_talk_allowed_2nd_pass {nick host hand chan text} {
	set coin [rand 101]
	set triggered ""
	# on cherche si la phrase contient un mot cl
	foreach word $megahal_interface::trigger_words {
		if { [regexp -nocase "(^|\[^a-zA-Z\])[regsub -all {[][\}\{$^?+*.()|\\]} [set word [subst $word]] \\\\&](\[^a-zA-Z\]|$)" $text] } { set triggered $word }
	}
	# ---------------------------------------------------------------------------
	if { (($megahal_interface::DEBUGMODE_chan eq "*") || ($chan eq $megahal_interface::DEBUGMODE_chan)) && ($megahal_interface::DEBUGMODE != 0) } {
		if { [lindex $megahal_interface::DEBUGMODE 0] } {
			putlog "\00304\[MEGAHAL DEBUG\]\003 \00306i!i\003\00313!i!\003\00314 dump \003is_talk_allowed_2nd_pass\00314 : $nick | $host | $hand ([chattr $hand $chan]) | $chan | $text\003"
		}
		if { [lindex $megahal_interface::DEBUGMODE 2] } {
			putlog "\00304\[MEGAHAL DEBUG\]\003 \00310i!i\003\00311!i!\003\00314 ENUMERATION DES CRITERES DE REPONSE (2EME PASSE)\003"
			if { [string match "$megahal_interface::force_L_R_cmd*" $text] } {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00303i!i\003\00309!i!\003\00314 la ligne commence par \"$megahal_interface::force_L_R_cmd\" : apprentissage forc + \003\00303\002rponse force\002\003\00314 si flags \003\00307$megahal_interface::force_L_R_auth\003"
			} elseif { [string match "$megahal_interface::force_noL_R_cmd*" $text] } {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00303i!i\003\00309!i!\003\00314 la ligne commence par \"$megahal_interface::force_noL_R_cmd\" : n'apprend pas + \003\00303\002rponse force\002\003\00314 si flags \003\00307$megahal_interface::force_noL_R_auth\003"
			}
			if { [llength $megahal_interface::talk_queue] < $megahal_interface::max_talk_queue } {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00303i!i\003\00309!i!\003\00314 La file d'attente contient \003\00307[llength $megahal_interface::talk_queue]\003\00314/\003\00307$megahal_interface::max_talk_queue\003\00314 entres\003"
			} else {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00305i!i\003\00304!i!\003\00314 La file d'attente est pleine (\003\00307[llength $megahal_interface::talk_queue]\003\00314/\003\00307$megahal_interface::max_talk_queue\003\00314)\003"
			}
			if { $megahal_interface::use_responder } {
				if { $megahal_interface::check_responder } {
					putlog "\00304\[MEGAHAL DEBUG\]\003 \00305i!i\003\00304!i!\003\00314 Responder a rpondu  \003\00307$text\003"
				} else {
					putlog "\00304\[MEGAHAL DEBUG\]\003 \00303i!i\003\00309!i!\003\00314 Responder n'a pas rpondu\003"
				}
			}
			putlog "\00304\[MEGAHAL DEBUG\]\003 \00314i!i\003\00315!i!\003\00314 tirage d'un nombre alatoire entre 1 et 100 afin de dterminer si le bot a le droit de rpondre : \003\00307$coin\003"
			if { ([channel get $chan megahal_respond]) && ($triggered ne "") } {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00303i!i\003\00309!i!\003\00314 au moins un mot cl prsent dans la liste \$trigger_words a t match (\003\00307 $triggered \003\00314)\003"
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00303i!i\003\00309!i!\003\00314 le bot a \003\00307$megahal_interface::keyreplyrate%\003\00314 de chances de rpondre si un mot cl est prononc (flag +megahal_respond).\003"
			}  else {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00305i!i\003\00304!i!\003\00314 aucun mot cl n'a t match ou flag -megahal_respond.\003"
			}
			if { [channel get $chan megahal_chatter] } {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00303i!i\003\00309!i!\003\00314 Le bot a \003\00307$megahal_interface::replyrate%\003\00314 de chances de rpondre  tout (flag +megahal_chatter).\003"
			} else {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00305i!i\003\00304!i!\003\00314 Le bot n'a pas la permission de parler librement (flag -megahal_chatter).\003"
			}
		}
	}
	# ---------------------------------------------------------------------------
	if { ((([string match "$megahal_interface::force_L_R_cmd*" $text]) && ([matchattr $hand $megahal_interface::force_L_R_auth $chan]))\
	 || (([string match "$megahal_interface::force_noL_R_cmd*" $text]) && ([matchattr $hand $megahal_interface::force_noL_R_auth $chan])))\
	 || (([llength $megahal_interface::talk_queue] < $megahal_interface::max_talk_queue)\
	 && (!$megahal_interface::check_responder)\
	 && ((([channel get $chan megahal_respond]) && ($triggered ne "") && ($coin <= $megahal_interface::keyreplyrate))\
	 || (([channel get $chan megahal_chatter]) && ($coin <= $megahal_interface::replyrate)))) } {
		return 1
	} else {
		if { (($megahal_interface::DEBUGMODE_chan eq "*") || ($chan eq $megahal_interface::DEBUGMODE_chan)) && ([lindex $megahal_interface::DEBUGMODE 2]) } {
			putlog "\00304\[MEGAHAL DEBUG\]\003 \002\00305i!i\003\00304!i!\003\002\00314 La parole n'a pas t autorise aprs passage en revue des critres.\003"
		}
		return 0
	}
}

###
### Autorisation de rpondre ? (3me passe : aprs passage de la moulinette,
### vrification que la rponse ne commence pas par une commande)
### (retourne 1 pour oui, 0 pour non)
###
proc megahal_interface::is_talk_allowed_3rd_pass {nick host hand chan text} {
	# ---------------------------------------------------------------------------
	if { (($megahal_interface::DEBUGMODE_chan eq "*") || ($chan eq $megahal_interface::DEBUGMODE_chan)) && ($megahal_interface::DEBUGMODE != 0) } {
		if { [lindex $megahal_interface::DEBUGMODE 0] } {
			putlog "\00304\[MEGAHAL DEBUG\]\003 \00306i!i\003\00313!i!\003\00314 dump \003is_talk_allowed_3rd_pass\00314 : $nick | $host | $hand ([chattr $hand $chan]) | $chan | $text\003"
		}
		if { [lindex $megahal_interface::DEBUGMODE 2] } {
			putlog "\00304\[MEGAHAL DEBUG\]\003 \00310i!i\003\00311!i!\003\00314 ENUMERATION DES CRITERES DE REPONSE (3EME PASSE)\003"
			if { ![megahal_interface::handle_command $text] } {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00305i!i\003\00304!i!\003\00314 la rponse contient une commande ne faisant pas partie des commandes autorises ( \00307[lindex [split $text] 0]\00314 )\003"
			} else {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00303i!i\003\00309!i!\003\00314 la rponse n'est pas une commande ou fait partie des commandes autorises.\003"
			}
		}
	}
	# ---------------------------------------------------------------------------
	if { [megahal_interface::handle_command $text] } {
		return 1
	} else {
		if { (($megahal_interface::DEBUGMODE_chan eq "*") || ($chan eq $megahal_interface::DEBUGMODE_chan)) && ([lindex $megahal_interface::DEBUGMODE 2]) } {
			putlog "\00304\[MEGAHAL DEBUG\]\003 \002\00305i!i\003\00304!i!\003\002\00314 La parole n'a pas t autorise aprs passage en revue des critres.\003"
		}
		return 0
	}

}

###
### Est-ce une commande et a-t-on l'autorisation de l'apprendre/utiliser ?
### (voir variables $command_prefixes et $allowed_commands)
### (retourne 1 si l'autorisation est donne, sinon 0)
###
proc megahal_interface::handle_command {text} {
	set text [regsub "^(\\$megahal_interface::force_L_R_cmd|\\$megahal_interface::force_noL_R_cmd|\\$megahal_interface::force_L_noR_cmd|\\$megahal_interface::force_noL_noR_cmd)" $text ""]
	foreach command $megahal_interface::allowed_commands {
		if { [string match $command* $text] } { return 1 }
	}	
	foreach symbol [split $megahal_interface::command_prefixes ""] {
		if { [string match $symbol* $text] } { return 0 }
	}
	return 1
}

###
### Apprentissage
###
proc megahal_interface::learn {nick clean_nick chan clean_chan text} {
	variable floodlock_learn
	if { (($megahal_interface::DEBUGMODE_chan eq "*") || ($chan eq $megahal_interface::DEBUGMODE_chan)) && ($megahal_interface::DEBUGMODE != 0) } {
		if { [lindex $megahal_interface::DEBUGMODE 0] } {
			putlog "\00304\[MEGAHAL DEBUG\]\003 \00306i!i\003\00313!i!\003\00314 dump \003learn\00314 : $nick | $clean_nick | $chan | $clean_chan | $text\003"
		}
		if { [lindex $megahal_interface::DEBUGMODE 1] } {
			putlog "\00304\[MEGAHAL DEBUG\]\003 \00314i!i\003\00315!i!\003\00314 appris\00307 $text \00314de \00307$nick\003"
		}
	}
	set floodlock_learn($clean_chan,$clean_nick) 1
	after [expr $megahal_interface::learn_interval * 1000] "megahal_interface::unfloodlock_learn $clean_chan $clean_nick"
	::megahal_learn $text
	return $text
}

###
### Parole
###
proc megahal_interface::talk {chan clean_chan nick clean_nick source reply} {
	if { (($megahal_interface::DEBUGMODE_chan eq "*") || ($chan eq $megahal_interface::DEBUGMODE_chan)) && ([lindex $megahal_interface::DEBUGMODE 0]) } {
		putlog "\00304\[MEGAHAL DEBUG\]\003 \00306i!i\003\00313!i!\003\00314 dump \003talk\00314 : $chan | $clean_chan | $nick | $clean_nick | $source | $reply\003"
	}
	# on lance un timer qui servira  savoir si le bot a dj rpondu  $nick
	# il y a moins de $megahal_interface::reply_interval secondes, afin d'viter plusieurs
	# rponses rapproches  la mme personne 
	set megahal_interface::floodlock_reply($clean_chan,$clean_nick) 1
	after [expr $megahal_interface::reply_interval * 1000] "megahal_interface::unfloodlock_reply $clean_chan $clean_nick"
	set pre_delay 0
	# Affichage d'une rponse neutre avant la rponse principale si $2nd_neutral_reply est activ
	if { ($megahal_interface::2nd_neutral_reply) && ($source eq "internal") && ([set coin [rand 101]] <= $megahal_interface::2nd_neutral_reply_rate) && ([set coin2 [rand 2]]) } {
		# remarque : le 1er argument signifie "rponse ajoute par Responder" (0=non 1=oui)
		lappend megahal_interface::talk_queue [list 0 $chan [subst [lindex $megahal_interface::2nd_neutral_pre_reply_list [rand [llength $megahal_interface::2nd_neutral_pre_reply_list]]]]]
#		set pre_delay [expr ([rand [expr [lindex $megahal_interface::2nd_neutral_reply_delay 1] - ([lindex $megahal_interface::2nd_neutral_reply_delay 0] - 1 )]] + [lindex $megahal_interface::2nd_neutral_reply_delay 0]) * 1000]
#		after $pre_delay megahal_interface::delayed_talk
	}
	# on retarde la rponse pour simuler la vitesse de frappe (coeff * sqrt(nombre de caractres) + offset)
#	set delay [expr $pre_delay + (round(($megahal_interface::reply_speed_coeff * sqrt([string length $reply])) + $megahal_interface::reply_speed_offset) * 1000 )]
	# on ajoute la rponse du bot dans la file d'attente, elle sera traite aprs le dlai.
	lappend megahal_interface::talk_queue [list 0 $chan $reply]
#	after $delay megahal_interface::delayed_talk
	# Affichage d'une rponse neutre aprs la rponse principale si $2nd_neutral_reply est activ
	if { ($megahal_interface::2nd_neutral_reply) && ($source eq "internal") && ($coin <= $megahal_interface::2nd_neutral_reply_rate) && !($coin2) } {
		lappend megahal_interface::talk_queue [list 0 $chan [subst [lindex $megahal_interface::2nd_neutral_post_reply_list [rand [llength $megahal_interface::2nd_neutral_post_reply_list]]]]]
#		after [expr $delay + (([rand [expr [lindex $megahal_interface::2nd_neutral_reply_delay 1] - ([lindex $megahal_interface::2nd_neutral_reply_delay 0] - 1 )]] + [lindex $megahal_interface::2nd_neutral_reply_delay 0]) * 1000)] megahal_interface::delayed_talk
	}
	if { !$::megahal_interface::delayed_talk_running } { megahal_interface::delayed_talk }
	if { (($megahal_interface::DEBUGMODE_chan eq "*") || ($chan eq $megahal_interface::DEBUGMODE_chan)) && ([lindex $megahal_interface::DEBUGMODE 2]) } {
#		putlog "\00304\[MEGAHAL DEBUG\]\003 \00314i!i\003\00315!i!\003 \00314rponse dans [expr $delay / 1000] secondes : \003\00303$reply\003"
		putlog "\00304\[MEGAHAL DEBUG\]\003 \00314i!i\003\00315!i!\003 \00314queue de rponses ([llength $megahal_interface::talk_queue]): $megahal_interface::talk_queue\003"
	}
}

###
### Traitement de la file d'attente de parole
###
proc megahal_interface::delayed_talk {} {
	# si la file d'attente de rponses est vide, on arrte
	if { ![llength $megahal_interface::talk_queue] } {
		variable delayed_talk_running 0
		return
	} else {
		variable delayed_talk_running 1
	}
	set is_from_responder [lindex $megahal_interface::talk_queue 0 0]
	set chan [lindex $megahal_interface::talk_queue 0 1]
	# Si la rponse ne provient pas de Responder
	if { !$is_from_responder } {

#		variable reply [lindex $megahal_interface::talk_queue 0 2]
		regsub -all {[\}\{\[\]\$"\\]} [lindex $megahal_interface::talk_queue 0 2] {\\&} reply  ; # "

		set output "puthelp \"PRIVMSG $chan :$reply\""
		set delay [expr round(($megahal_interface::reply_speed_coeff * sqrt([::tcl::string::length $reply])) + $megahal_interface::reply_speed_offset) * 1000]
		# le 1er argument est le type (0=N/A 1=normal 2=notice 3=/me)
		# le 2me argument signifie "ajouter au log ?" (0=non 1=oui)
		after $delay megahal_interface::display_response [list 1 1 $chan $output $reply]
	# Si la rponse provient de Responder
	} else {
		regsub -all {[\}\{\[\]\$"\\]} [join [lindex $megahal_interface::talk_queue 0 2]] {\\&} reply  ; # "
		set first_word ""
		regexp {([^ ]*) (.*)} $reply dummy first_word leftovers
		switch -exact -- [::tcl::string::tolower $first_word] {
			"/putserv" {
				set output "putserv \"$leftovers\""
				set delay 0
				after $delay megahal_interface::display_response [list 0 0 $chan $output "-"]
			}
			"/notice" {
				regexp {([^ ]*) (.*)} $leftovers dummy target leftovers
				set output "puthelp \"NOTICE $target :$leftovers\""
				set delay [expr round(($megahal_interface::reply_speed_coeff * sqrt([::tcl::string::length $leftovers])) + $megahal_interface::reply_speed_offset) * 1000]
				if { ![::tcl::string::first "#" $target] } {
					after $delay megahal_interface::display_response [list 2 1 $chan $output $leftovers]
				} else {
					after $delay megahal_interface::display_response [list 0 0 $chan $output "-"]
				}
			}
			"/me" {
				regexp {([^ ]*) (.*)} $leftovers dummy target leftovers
				set output "puthelp \"PRIVMSG $target :\\001ACTION $leftovers\\001\""
				set delay [expr round(($megahal_interface::reply_speed_coeff * sqrt([::tcl::string::length $leftovers])) + $megahal_interface::reply_speed_offset) * 1000]
				if { ![::tcl::string::first "#" $target] } {
					after $delay megahal_interface::display_response [list 3 1 $chan $output $leftovers]
				} else {
					after $delay megahal_interface::display_response [list 0 0 $chan $output "-"]
				}
			}
			"/msg" {
				regexp {([^ ]*) (.*)} $leftovers dummy target leftovers
				set output "puthelp \"PRIVMSG $target :$leftovers\""
				set delay [expr round(($megahal_interface::reply_speed_coeff * sqrt([::tcl::string::length $leftovers])) + $megahal_interface::reply_speed_offset) * 1000]
				if { ![::tcl::string::first "#" $target] } {
					after $delay megahal_interface::display_response [list 1 1 $chan $output $leftovers]
				} else {
					after $delay megahal_interface::display_response [list 0 0 $chan $output "-"]
				}
			}
			default {
				set output "puthelp \"PRIVMSG $chan :$reply\""
				set delay [expr round(($megahal_interface::reply_speed_coeff * sqrt([::tcl::string::length $reply])) + $megahal_interface::reply_speed_offset) * 1000]
				after $delay megahal_interface::display_response [list 1 1 $chan $output $reply]
			}
		}
	}
	if { (($megahal_interface::DEBUGMODE_chan eq "*") || ($chan eq $megahal_interface::DEBUGMODE_chan)) && ([lindex $megahal_interface::DEBUGMODE 2]) } {
		putlog "\00304\[MEGAHAL DEBUG\]\003 \00314i!i\003\00315!i!\003 \00314Rponse dans [expr $delay / 1000]s \00314--$chan-->\003 $output\003"
	}
 	return
}

###
### Affichage d'une rponse sur un chan
###
proc megahal_interface::display_response {type add_to_log chan output reply} {
	eval $output
	# on crit dans le log du chan ce que le bot dit car le logger interne ne le fait pas
	if { $add_to_log } {
		switch -exact -- $type {
			"1" {
				putloglev p $chan "<$::botnick> $reply"
			}
			"2" {
				putloglev p $chan "-[set ::botnick]:[set chan]- $reply"
			}				
			"3" {
				putloglev p $chan "* $::botnick $reply"
			}
		}
	}
	# on limine la 1re rponse de la file d'attente car elle a t traite
	set megahal_interface::talk_queue [lreplace $megahal_interface::talk_queue 0 0]
	megahal_interface::delayed_talk
	return
}

###
### Suppression d'un floodlock_learn (floodlock_learn = MegaHAL n'apprend plus rien venant de $nick)
###
proc megahal_interface::unfloodlock_learn {chan nick} {
	if { [info exists megahal_interface::floodlock_learn($chan,$nick)] } {
		unset megahal_interface::floodlock_learn($chan,$nick)
	}
	return
}

###
### Suppression d'un floodlock_reply (floodlock_reply = MegaHAL ne rpond plus  $nick)
###
proc megahal_interface::unfloodlock_reply {chan nick} {
	if { [info exists megahal_interface::floodlock_reply($chan,$nick)] } {
		unset megahal_interface::floodlock_reply($chan,$nick)
	}
	return
}

###
### Suppression du mode "ta gueule"
###
proc megahal_interface::unshutup {chan} {
	if { [info exists megahal_interface::shutup($chan)] } {
		if { (($megahal_interface::DEBUGMODE_chan eq "*") || ($chan eq $megahal_interface::DEBUGMODE_chan)) && ([lindex $megahal_interface::DEBUGMODE 5]) && ($megahal_interface::shutup($chan)) } {
			putlog "\00304\[MEGAHAL\] \002Mode TAGUEULE dsactiv sur $chan aprs [set megahal_interface::shutup_time]mn\002\003"
		}
		unset megahal_interface::shutup($chan)
	}
	return
}

###
### Affichage de l'aide en fonction des autorisations
###
proc megahal_interface::pub_help {nick host hand chan args} {
	if { ![channel get $chan megahal] } { return }
	regexp {(.*) (.*)} [split [chattr $hand $chan] "|"] dummy user_global_flags user_local_flags
	if {$hand eq "*"} {
		set user_local_flags "-"
		set user_global_flags "-"
	}
	if {$megahal_interface::help_mode} { set help_mode "PRIVMSG" } { set help_mode "NOTICE" }
	set cmd_prefix_list {masterswitch learnstate respondstate chatterstate replyrate keyreplyrate forget forgetword seekstatement countword learnfile savebrain reloadbrain reloadphrases trimbrain lobotomy restorebrain chanstatus braininfo memusage treesize viewbranch force_L_R force_noL_R force_L_noR force_noL_noR}
	foreach command [split $cmd_prefix_list " "] {
		set flags [set megahal_interface::[subst $command]_auth]
		regexp {(.*)\|(.*)} $flags dummy cmd_global_flags cmd_local_flags
		if { ([regexp "\[$cmd_global_flags\]" "-$user_global_flags"]) || ([regexp "\[$cmd_local_flags\]" "-$user_local_flags"]) } { set cmd_allowed 1 } { set cmd_allowed 0 }
		if {$cmd_allowed} {
			if {![info exists help_list]} {
				lappend help_list "\037Commandes de l'Interface MegaHAL\037 :"
			} elseif { $help_list ne "" } {
				lappend help_list " \00307|\003 "
			}
			switch -- $command {
				"masterswitch" { lappend help_list "\002$megahal_interface::masterswitch_cmd\002\ \00314<\003on\00314/\003off\00314>\003 : active/dsactive l'I.A." }
				"learnstate" { lappend help_list "\002$megahal_interface::learnstate_cmd\002 \00314<\003on\00314/\003off\00314>\003 : active/dsactive l'apprentissage" }
				"respondstate" { lappend help_list "\002$megahal_interface::respondstate_cmd\002 \00314<\003on\00314/\003off\00314>\003 : active/dsactive la rponse sur dtection de mots cls" }
				"chatterstate" { lappend help_list "\002$megahal_interface::chatterstate_cmd\002 \00314<\003on\00314/\003off\00314>\003 : active/dsactive la libre expression" }
				"replyrate" { lappend help_list "\002$megahal_interface::replyrate_cmd\002 \00314\[\003taux de rponse\00314\]\003 : interrogation/rglage du taux de rponse gnral" }
				"keyreplyrate" { lappend help_list "\002$megahal_interface::keyreplyrate_cmd\002 \00314\[\003taux de rponse\00314\]\003 : interrogation/rglage du taux de rponse en cas d'utilisation de mot cl" }
				"forget" { lappend help_list "\002$megahal_interface::forget_cmd\002 \00314<\003phrase\00314>\003 : force l'I.A.  oublier une phrase" }
				"forgetword" { lappend help_list "\002$megahal_interface::forgetword_cmd\002 \00314<\003mot\00314>\003 : force l'I.A.  oublier toutes les occurrences d'un mot (toutes les phrases contenant ce mot seront galement oublies)" }
				"seekstatement" { lappend help_list "\002$megahal_interface::seekstatement_cmd\002 \00314<\003phrase\00314>\003 : vrifie si l'I.A. connait une phrase donne" }
				"countword" { lappend help_list "\002$megahal_interface::countword_cmd\002 \00314<\003mot\00314>\003 : vrifie si l'I.A. connait un mot donn et en compte toutes les occurrences." }
				"learnfile" { lappend help_list "\002$megahal_interface::learnfile_cmd\002 \00314<\003chemin/fichier\00314>\003 : apprend le contenu d'un fichier  l'I.A." }
				"savebrain" { lappend help_list "\002$megahal_interface::savebrain_cmd\002 : sauvegarde l'I.A." }
				"reloadbrain" { lappend help_list "\002$megahal_interface::reloadbrain_cmd\002 : recharge l'I.A." }
				"reloadphrases" { lappend help_list "\002$megahal_interface::reloadphrases_cmd\002 : recharge les phrases" }
				"trimbrain" { lappend help_list "\002$megahal_interface::trimbrain_cmd\002 \00314\[\003nombre de nodes\00314\]\003 : lague l'I.A.; si le nombre de nodes n'est pas spcifi, utilise la valeur de \$::maxsize" }
				"lobotomy" { lappend help_list "\002$megahal_interface::lobotomy_cmd\002 : effectue un lavage de cerveau." }
				"restorebrain" { lappend help_list "\002$megahal_interface::restorebrain_cmd\002 : recharge un backup de l'I.A. (aprs un $megahal_interface::lobotomy_cmd)" }
				"chanstatus" { lappend help_list "\002$megahal_interface::chanstatus_cmd\002 : affiche le statut de l'I.A." } 
				"braininfo" { lappend help_list "\002$megahal_interface::braininfo_cmd\002 : affiche des informations sur l'I.A." }
				"memsize" { lappend help_list "\002$megahal_interface::braininfo_cmd\002 : affiche une estimation de la quantit de mmoire utilise par l'I.A." }
				"treesize" { lappend help_list "\002$megahal_interface::treesize_cmd\002 : affiche des statistiques sur une branche ou une sous-branche" }
				"viewbranch" { lappend help_list "\002$megahal_interface::viewbranch_cmd\002 : affiche le contenu d'une branche ou d'une sous-branche" }
				"force_L_R" { lappend help_list "\002$megahal_interface::force_L_R_cmd\002\00314<\003phrase\00314>\003 : force MegaHAL  apprendre + rpondre" }
				"force_noL_R" { lappend help_list "\002$megahal_interface::force_noL_R_cmd\002\00314<\003phrase\00314>\003 : force MegaHAL  ne pas apprendre + rpondre" }
				"force_L_noR" { lappend help_list "\002$megahal_interface::force_L_noR_cmd\002\00314<\003phrase\00314>\003 : force MegaHAL  apprendre + ne pas rpondre" }
				"force_noL_noR" { lappend help_list "\002$megahal_interface::force_noL_noR_cmd\002\00314<\003phrase\00314>\003 : force MegaHAL  ne pas apprendre + ne pas rpondre" }
			}
			if {[string length [join $help_list]] > 275} {
				puthelp "$help_mode $nick :[join [split [join $help_list]]]"
				set help_list ""
			}
		}
	}
	puthelp "$help_mode $nick :[join [split [join $help_list]]]"
}

###
### Gestion du flag +/-megahal
###
proc megahal_interface::pub_masterswitch {nick host hand chan arg} {
	if { ([llength $arg] != 1) || (($arg ne "on") && ($arg ne "off")) } {
		puthelp "PRIVMSG $chan :\037Syntaxe\037 : \002$megahal_interface::masterswitch_cmd\002 \00314<\003on\00314/\003off\00314>\003 \00307|\003 Active/dsactive l'I.A. sur $chan."
		return
	}
	if { $arg eq "on" } {
		if {[channel get $chan megahal] == 0} {
			channel set $chan +megahal
			puthelp "PRIVMSG $chan :\00314L'I.A. est active.\003"
		} else {
			puthelp "PRIVMSG $chan :\00314L'I.A. est dj active.\003"
		}
	} elseif { $arg eq "off" } {
		if {[channel get $chan megahal] == 1} {
			channel set $chan -megahal
			puthelp "PRIVMSG $chan :\00314L'I.A. est dsactive.\003"
		} else {
			puthelp "PRIVMSG $chan :\00314L'I.A. est dj dsactive.\003"
		}
	}
}

###
### Gestion du flag +/-megahal_learn
###
proc megahal_interface::pub_learnstate {nick host hand chan arg} {
	if { ![channel get $chan megahal] } { return }
	if { ([llength $arg] != 1) || (($arg ne "on") && ($arg ne "off")) } {
		puthelp "PRIVMSG $chan :\037Syntaxe\037 : \002$megahal_interface::learnstate_cmd\002 \00314<\003on\00314/\003off\00314>\003 \00307|\003 Active/dsactive l'apprentissage sur $chan."
		return
	}
	if { $arg eq "on" } {
		if {[channel get $chan megahal_learn] == 0} {
			channel set $chan +megahal_learn
			puthelp "PRIVMSG $chan :\00314L'apprentissage est activ (\003\00307$megahal_interface::learnrate%\003\00314 de chances).\003"
		} else {
			puthelp "PRIVMSG $chan :\00314L'apprentissage est dj activ (\003\00307$megahal_interface::learnrate%\003\00314 de chances).\003"
		}
	} elseif { $arg eq "off" } {
		if {[channel get $chan megahal_learn] == 1} {
			channel set $chan -megahal_learn
			puthelp "PRIVMSG $chan :\00314L'apprentissage est dsactiv.\003"
		} else {
			puthelp "PRIVMSG $chan :\00314L'apprentissage est dj dsactiv.\003"
		}
	}
}

###
### Gestion du flag +/-megahal_respond
###
proc megahal_interface::pub_respondstate {nick host hand chan arg} {
	if { ![channel get $chan megahal] } { return }
	if { ([llength $arg] != 1) || (($arg ne "on") && ($arg ne "off")) } {
		puthelp "PRIVMSG $chan :\037Syntaxe\037 : \002$megahal_interface::respondstate_cmd\002 \00314<\003on\00314/\003off\00314>\003 \00307|\003 Active/dsactive la rponse sur dtection de mots cls sur $chan."
		return
	}
	if { $arg eq "on" } {
		if {[channel get $chan megahal_respond] == 0} {
			channel set $chan +megahal_respond
			puthelp "PRIVMSG $chan :\00314La rponse sur dtection de mots cls est active (\003\00307$megahal_interface::keyreplyrate%\003\00314 de chances).\003"
		} else {
			puthelp "PRIVMSG $chan :\00314La rponse sur dtection de mots cls est dj active (\003\00307$megahal_interface::keyreplyrate%\003\00314 de chances).\003"
		}
	} elseif { $arg eq "off" } {
		if {[channel get $chan megahal_respond] == 1} {
			channel set $chan -megahal_respond
			puthelp "PRIVMSG $chan :\00314La rponse sur dtection de mots cls est dsactive.\003"
		} else {
			puthelp "PRIVMSG $chan :\00314La rponse sur dtection de mots cls est dj dsactive.\003"
		}
	}
}

###
### Gestion du flag +/-megahal_chatter
###
proc megahal_interface::pub_chatterstate {nick host hand chan arg} {
	if { ![channel get $chan megahal] } { return }
	if { ([llength $arg] != 1) || (($arg ne "on") && ($arg ne "off")) } {
		puthelp "PRIVMSG $chan :\037Syntaxe\037 : \002$megahal_interface::chatterstate_cmd\002 \00314<\003on\00314/\003off\00314>\003 \00307|\003 Active/dsactive la libre expression sur $chan."
		return
	}
	if { $arg eq "on" } {
		if {[channel get $chan megahal_chatter] == 0} {
			channel set $chan +megahal_chatter
			puthelp "PRIVMSG $chan :\00314La libre expression est active (\003\00307$megahal_interface::replyrate%\003\00314 de chances).\003"
		} else {
			puthelp "PRIVMSG $chan :\00314La libre expression est dj active (\003\00307$megahal_interface::replyrate%\003\00314 de chances).\003"
		}
	} elseif { $arg eq "off" } {
		if {[channel get $chan megahal_chatter] == 1} {
			channel set $chan -megahal_chatter
			puthelp "PRIVMSG $chan :\00314La libre expression est dsactive.\003"
		} else {
			puthelp "PRIVMSG $chan :\00314La libre expression est dj dsactive.\003"
		}
	}
}

###
### Interrogation / rglage du taux de rponse gnral
###
proc megahal_interface::pub_replyrate {nick host hand chan args} {
	if { ![channel get $chan megahal] } { return }
	variable replyrate
	set args [lindex $args 0]
	set args [split $args " "]
	if {[lindex $args 0] == ""} {
		puthelp "PRIVMSG $chan :\00314Taux de rponses actuellement dfini  \003\00307$replyrate%\003"
	} else {
		variable replyrate $args
		puthelp "PRIVMSG $chan :\00314Taux de rponses dfini  \003\00307$replyrate%\003"
	}
}

###
### Interrogation / rglage du taux de rponse en cas d'utilisation de mot cl
###
proc megahal_interface::pub_keyreplyrate {nick host hand chan args} {
	if { ![channel get $chan megahal] } { return }
	set args [lindex $args 0]
	set args [split $args " "]
	if {[lindex $args 0] == ""} {
		puthelp "PRIVMSG $chan :\00314Taux de rponses si mot cl dtect actuellement dfini  \003\00307$megahal_interface::keyreplyrate%\003"
	} else {
		variable keyreplyrate $args
		puthelp "PRIVMSG $chan :\00314Taux de rponses si mot cl dtect dfini  \003\00307$megahal_interface::keyreplyrate%\003"
	}
}

###
### Elagage + sauvegarde du cerveau
###
proc megahal_interface::auto_savebrain {min hour day month year} {
	trimbrain $::maxsize
	savebrain
}
proc megahal_interface::on_event_savebrain {args} {
	trimbrain $::maxsize
	savebrain
}

###
### Sauvegarde manuelle du cerveau
###
proc megahal_interface::pub_savebrain {nick host hand chan arg} {
	if { ![channel get $chan megahal] } { return }
	savebrain
	puthelp "PRIVMSG $chan :\00314Cerveau sauvegard.\003"
}

###
### Re-lecture du cerveau  partir du fichier brain
###
proc megahal_interface::pub_reloadbrain {nick host hand chan arg} {
	if { ![channel get $chan megahal] } { return }
	reloadbrain
	puthelp "PRIVMSG $chan :\00314Cerveau recharg.\003"
}

###
### Re-lecture des phrases (fichier .phr)
###
proc megahal_interface::pub_reloadphrases {nick host hand chan arg} {
	if { ![channel get $chan megahal] } { return }
	reloadphrases
	puthelp "PRIVMSG $chan :\00314Phrases recharges.\003"
}

###
### Elagage manuel du cerveau
###
proc megahal_interface::pub_trimbrain {nick host hand chan arg} {
	if { ![channel get $chan megahal] } { return }
	set arg [lindex $arg 0]
	if {$arg == "" || ![string is digit $arg]} {
		set arg $::maxsize
	}
	trimbrain $arg
	puthelp "PRIVMSG $chan :\00314Cerveau lagu  \003\00307$arg\003\00314 noeuds d'association.\003"
}

###
### Cration d'un backup puis effacement complet du cerveau
###
proc megahal_interface::pub_lobotomy {nick host hand chan arg} {
	if { ![channel get $chan megahal] } { return }
	savebrain
	if { [file exists megahal.brn] } {
		if { [file exists megahal.old] } { file delete -force megahal.old }
		file copy -force megahal.brn megahal.old
		file delete -force megahal.brn
	}
	reloadbrain
	savebrain
	puthelp "PRIVMSG $chan :\00314Lobotomie termine. Cration d'un nouveau cerveau...\003" 
}

###
### Restauration d'un backup du cerveau
###
proc megahal_interface::pub_restorebrain {nick host hand chan arg} {
	if { ![channel get $chan megahal] } { return }
  if {[file exists megahal.old]} {
    file delete megahal.brn
    file copy megahal.old megahal.brn
    reloadbrain
    puthelp "PRIVMSG $chan :\00314Ancien cerveau restaur.\003"
  } else {
    puthelp "PRIVMSG $chan :\00314L'ancien cerveau n'a pas t trouv.\003" 
  }
}

###
### Oublier une phrase
###
proc megahal_interface::pub_forget {nick host hand chan arg} {
	if { ![channel get $chan megahal] } { return }
	if { ([llength $arg] == 0) } {
		puthelp "PRIVMSG $chan :\037Syntaxe\037 : \002$megahal_interface::forget_cmd\002 \00314<\003phrase\00314>\003 \00307|\003 Force l'I.A.  oublier une phrase."
		return
	}
	*pub:.forget - - - $chan $arg
}

###
### Oublier toutes les occurrences d'un mot
###
proc megahal_interface::pub_forgetword {nick host hand chan arg} {
	if { ![channel get $chan megahal] } { return }
	if { ([llength $arg] != 1) } {
		puthelp "PRIVMSG $chan :\037Syntaxe\037 : \002$megahal_interface::forgetword_cmd\002 \00314<\003mot\00314>\003 \00307|\003 Force l'I.A.  oublier toutes les occurrences d'un mot. Veuillez noter que toutes les phrases contenant ce mot seront galement oublies."
		return
	}
	*pub:.forgetword - - - $chan $arg
}

###
### Vrifier si l'IA connat une phrase donne
###
proc megahal_interface::pub_seekstatement {nick host hand chan arg} {
	if { ![channel get $chan megahal] } { return }
	if { ([llength $arg] == 0) } {
		puthelp "PRIVMSG $chan :\037Syntaxe\037 : \002$megahal_interface::seekstatement_cmd\002 \00314<\003phrase\00314>\003 \00307|\003 Recherche dans le cerveau de l'I.A. si une phrase donne est connue."
		return
	}
	*pub:.megaseek - - - $chan $arg
}

###
### Compter le nombre d'associations pour un mot donn
###
proc megahal_interface::pub_countword {nick host hand chan arg} {
	if { ![channel get $chan megahal] } { return }
	if { ([llength $arg] == 0) } {
		puthelp "PRIVMSG $chan :\037Syntaxe\037 : \002$megahal_interface::countword_cmd\002 \00314<\003mot\00314>\003 \00307|\003 Compte le nombre d'associations pour un mot donn."
		return
	}
	*pub:.megacount - - - $chan $arg
}

###
### Apprend le contenu d'un fichier  l'I.A.
###
proc megahal_interface::pub_learnfile {nick host hand chan arg} {
	if { ![channel get $chan megahal] } { return }
	if { [llength $arg] != 1 } {
		puthelp "PRIVMSG $chan :\037Syntaxe\037 : \002$megahal_interface::learnfile_cmd\002 \00314<\003nom et emplacement du fichier\00314>\003 \00307|\003 Apprend le contenu d'un fichier  l'I.A."
		return
	}
	if { [file readable $arg] } {
		learnfile $arg
		puthelp "PRIVMSG $chan :\00314Le contenu du fichier\00307 $arg \00314a t appris."
	} else {
		puthelp "PRIVMSG $chan :\00314Le fichier\00307 $arg \00314est inexistant ou je n'ai pas les autorisations ncessaires pour y accder."
	}
}

###
### Affiche des informations sur l'I.A.
###
proc megahal_interface::pub_braininfo {nick host hand chan arg} {
	if { ![channel get $chan megahal] } { return }
	set for [treesize -1 0]
	set back [treesize -1 1]
	puthelp "PRIVMSG $chan :\00314Mon I.A. comprend actuellement \003\00307[lindex $for 0]\003\00314 mots organiss en \003\00307[expr [lindex $for 1]+[lindex $back 1]]\003\00314 noeuds d'association.\003" 
	if { ![channel get $chan megahal_chatter] } {
		lappend output "\00314Ma libre expression est dsactive, "
	} else {
		lappend output "\00314J'ai \003\00307$megahal_interface::replyrate%\003\00314 de chances de rpondre  tout, "
	}
	if { ![channel get $chan megahal_respond] } {
		lappend output "je ne ragis pas lorsqu'on parle de moi, "
	} else {
		lappend output "\003\00307$megahal_interface::keyreplyrate%\003\00314 de chances de rpondre quand on parle de moi, "
	}
	if { ![channel get $chan megahal_respond] } {
		lappend output "et je n'apprends pas.\003"
	} else {
		lappend output "et j'ai \003\00307$megahal_interface::learnrate%\003\00314 de chances d'apprendre ce que vous dites si la phrase fait au moins \003\00307$megahal_interface::minlearnwords\003\00314 mots.\003"
	}
	puthelp "PRIVMSG $chan :[join $output]"
	puthelp "PRIVMSG $chan :\00314Les phrases que je construis ne dpassent jamais \003\00307$::maxreplywords\003\00314 mots, sont choisies dans un contexte d'une profondeur de \003\00307$::mega_order\003\00314 niveaux et l'improvisation est \003\00307[if { $::surprise } { set dummy "active" } { set dummy "dsactive" }]\003\00314.\003"
  if {[file exists megahal.old]} {
    puthelp "PRIVMSG $chan :\00314Mon apprentissage a dbut le \003\00307[strftime "%d/%m/%Y  %Hh%M" [file mtime megahal.old]]\003\00314.\003" 
  }
}

###
### Affiche le statut des flags sur le chan en cours
### (megahal megahal_learn megahal_chatter megahal_respond)
proc megahal_interface::pub_chanstatus {nick host hand chan arg} {
	puthelp "PRIVMSG $chan :\00314Statut des flags sur le chan \002$chan\002 : \003\00307[megahal_interface::flagstate [channel get $chan megahal]]megahal [megahal_interface::flagstate [channel get $chan megahal_learn]]megahal_learn [megahal_interface::flagstate [channel get $chan megahal_chatter]]megahal_chatter [megahal_interface::flagstate [channel get $chan megahal_respond]]megahal_respond\003"
}
proc megahal_interface::flagstate {value} {
	if { !$value } { return "-" } { return "+" }
}

###
### Affiche une estimation de la quantit de mmoire utilise par l'I.A.
###
proc megahal_interface::pub_memusage {nick host hand chan arg} {
	if { ![channel get $chan megahal] } { return }
		puthelp "PRIVMSG $chan :\00314Estimation de la quantit de mmoire utilise par l'I.A. : \003\00307[megahal_interface::octet_formatting [megahal_expmem]]\003\00314.\003"
}

###
### Affiche des statistiques sur une branche ou une sous-branche dans le cerveau
### de l'I.A. (nombre de branches (mots), nombre de noeuds d'association, nombre
### de branches au niveau suprieur/infrieur, compteur d'utilisation).
### Si un numro de branche est spcifi, affiche une sous-branche des 2
### arborescences principales.
### Il est possible de spcifier si vous souhaitez la branche parente ou la
### branche fille.
###
proc megahal_interface::pub_treesize {nick host hand chan arg} {
	if { ![channel get $chan megahal] } { return }
	if { [llength $arg] == 0 } {
		puthelp "PRIVMSG $chan :\037Syntaxe\037 : \002$megahal_interface::treesize_cmd\002 \00314<\003n de branche\00314> <\003parente/fille (1/0)\00314>\003 \00307|\003 Affiche des statistiques sur une branche ou une sous-branche dans le cerveau de l'I.A. (nombre de branches (mots), nombre de noeuds d'association, nombre de branches au niveau suprieur/infrieur, compteur d'utilisation). Si un numro de branche est spcifi, affiche une sous-branche des 2 arborescences principales."
		return
	}
	puthelp "PRIVMSG $chan :\00314[treesize $arg]\003"
}

###
### Affiche le contenu d'une branche ou d'une sous-branche dans le cerveau de
### l'I.A.
###
proc megahal_interface::pub_viewbranch {nick host hand chan arg} {
	if { ![channel get $chan megahal] } { return }
	if { [llength $arg] == 0 } {
		puthelp "PRIVMSG $chan :\037Syntaxe\037 : \002$megahal_interface::viewbranch_cmd\002 \00314<\003n de branche\00314> <\003parente/fille (1/0)\00314>\003 \00307|\003 Affiche le contenu d'une branche ou d'une sous-branche dans le cerveau de l'I.A."
		return
	}
	set output [split [viewbranch $arg] "\n"]
	puthelp "PRIVMSG $chan :\00314[llength $output] lments dans cette branche :\003"
	foreach element [split [viewbranch $arg] "\n"] {
		puthelp "PRIVMSG $chan :\00314$element\003"
	}
}

###
### Suppression espaces en double, espaces en dbut/fin de ligne, codes de couleur / gras / soulign / ...
###
proc megahal_interface::strip_codes_trim_spaces {text} { 
	return [string trim [regsub -all {\s+} [string map -nocase {"\017" ""} [stripcodes abcgru $text]] " "]]
}

###
### Neutralisation des caractres qui choquent Tcl
###
proc megahal_interface::neutralize_special_chars {data} {
	return [string map {"\[" "%!" "\]" "!%" "\\" "!@" "\|" "@!" "\{" ":!" "\}" "!:" "\^" "!" "\$" "!"} $data]
}

###
### Restauration des caractres qui choquent Tcl
###
proc megahal_interface::restore_special_chars {data} {
	return [string map {"%!" "\[" "!%" "\]" "!@" "\\" "@!" "\|" ":!" "\{" "!:" "\}" "!" "\^" "!" "\$"} $data]
}

###
### Conversion octets en Ko/Mo/Go/To/Po
###
proc megahal_interface::octet_formatting {value} {
	if { $value < 1000 } { return $value }
	foreach unit {Ko Mo Go To Po} {
		set value [expr $value / 1024.]
		if { $value < 1000 } {
			return [format %1.2f $value]$unit
		}
	}
}

###
### Mlange alatoire des lments d'une liste
###
proc megahal_interface::randomize_list {data} {
	set list_length [llength $data]
	for { set counter 1 } { $counter <= $list_length } { incr counter } {
		set index [rand [expr $list_length - $counter + 1]]
		lappend randomized_list [lindex $data $index]
		set data [lreplace $data $index $index]
	}
	return $randomized_list
}

###
### Contrle du flood
### Le paramtre action peut valoir "check" ou "add_instance"
### (retourne 1 si flood dtect, 0 sinon)
###
proc megahal_interface::flood {chan action} {
	variable instance
	set chan [megahal_interface::neutralize_special_chars $chan]
	if {![info exists instance($chan)]} { set instance($chan) 0 }
	set max_instances [lindex $megahal_interface::floodlimiter 0]
	set instance_length [expr [lindex $megahal_interface::floodlimiter 1] * 1000]
	if { $action eq "check" } { 
		if { $instance($chan) >= $max_instances } {
			if { (($megahal_interface::DEBUGMODE_chan eq "*") || ($chan eq $megahal_interface::DEBUGMODE_chan)) && ([lindex $megahal_interface::DEBUGMODE 6]) } {
				putlog "\00304\[MEGAHAL DEBUG\]\003 \00305i!i\003\00304!i!\003\00314 flood dtect sur $chan -> instances \003\00307$megahal_interface::instance($chan) \003\00314 >= \003\00307$megahal_interface::floodlimiter\003"
			}
			return 1
		} else {
			return 0
		}
	} else {
		incr instance($chan)
		after $instance_length "megahal_interface::antiflood_close_instance $chan"
		if { (($megahal_interface::DEBUGMODE_chan eq "*") || ($chan eq $megahal_interface::DEBUGMODE_chan)) && ([lindex $megahal_interface::DEBUGMODE 6]) } {
			putlog "\00304\[MEGAHAL DEBUG\]\003 \00314i!i\003\00315!i!\003\00314 instance anti-flood \003\00307+1\003\00314 sur $chan -> \003\00307$megahal_interface::instance($chan)\003\00314. (limite : $megahal_interface::floodlimiter)\003"
		}
		return "+"
	}
}
proc megahal_interface::antiflood_close_instance {chan} {
  variable instance
  if { ([info exists instance($chan)]) && ($instance($chan) > 0) } { incr instance($chan) -1 }
}

###
### Traitement des donnes avant apprentissage ou soumission  getreply
###
proc megahal_interface::moulinex_in {mode nick chan text} {
	if { (($megahal_interface::DEBUGMODE_chan eq "*") || ($chan eq $megahal_interface::DEBUGMODE_chan)) && ([lindex $megahal_interface::DEBUGMODE 0]) } {
		putlog "\00304\[MEGAHAL DEBUG\]\003 \00306i!i\003\00313!i!\003\00314 dump \003moulinex_in\00314 : $mode | $nick | $chan | $text\003"
	}
	# on filtre "$::botnick>" "$::botnick:" "$::botnick," ... en dbut de phrase
	set text [regsub -nocase "^@?$::botnick\\s?(\[^a-zA-Z\\s\]+)\\s?" $text ""]
	# on filtre les pseudos de la forme <nick> dans les copier/coller
	set text [regsub -all {<[^>]*>} $text ""]
	# on filtre les timestamp de la forme [timestamp] et (timestamp) dans les copier/coller
	set text [regsub -all {(\[|\()[0-9:\.]+(\]|\))} $text ""]
	# on supprime les flches -> <-  dans le texte
	# set text [regsub -all -- {(<[-=]+|[-=]+>)} $text ""]
	# on filtre les pseudos de type HL en dbut de ligne comme "pseudo >" ou "pseudo :" ...
	set text [regsub -nocase {^\s?@?[^\s]+\s?(>+|:|,|~|)\s?} $text ""]
	# ajout d'un " " en dbut de ligne (il nous servira de repre dans les string map)
	set text " $text"
	# ajout d'un "." en fin de ligne (il nous servira de repre dans les string map)
	if { [string index $text end] ne "." } { set text "$text." }
	# substitutions diverses vous pouvez utiliser les variables $::botnick, $nick et $chan
	set text [string map -nocase [list\
		"le $::botnick est "										"je suis "\
		"le $::botnick n'est "									"je ne suis "\
		" et $::botnick"												" et moi"\
		"  $::botnick"													"  moi"\
		" a $::botnick"													"  moi"\
		"avec $::botnick"												"avec moi"\
		" ce $::botnick"												" quand mme"\
		"c'est $::botnick"											"c'est moi"\
		"c'tait $::botnick"										"c'tait moi"\
		"c'etait $::botnick"										"c'etait moi"\
		"est pas $::botnick"										"est pas moi"\
		"sais pas $::botnick"										"sais pas"\
		"comme $::botnick"											"comme moi"\
		"$::botnick tu "												"tu "\
		"$::botnick je te "											"tu me "\
		"$::botnick je t'ai "										"tu m'as "\
		"$::botnick je t'"											"tu m'"\
		"$::botnick je "												"je "\
		"$::botnick j'"													"tu "\
		"$::botnick il a "											"j'ai "\
		"$::botnick il n'a "										"je n'ai "\
		"$::botnick il est interdit"						"il est interdit"\
		"$::botnick il est dconseill"					"il est dconseill"\
		"$::botnick il est conseill"						"il est conseill"\
		"$::botnick il est formellement"				"il est formellement"\
		"$::botnick il est "										"je suis "\
		"$::botnick il n'est "									"je ne suis "\
		"$::botnick il faut "										"il faut "\
		"$::botnick tu as "											"j'ai "\
		"$::botnick tu n'as "										"je n'ai "\
		"$::botnick tu est "										"je suis "\
		"$::botnick tu n'est "									"je ne suis "\
		"$::botnick tu es "											"je suis "\
		"$::botnick tu n'es "										"je ne suis "\
		"$::botnick fait "											"je fais "\
		"$::botnick ne fait "										"je ne fais "\
		"$::botnick fais "											"tu fais "\
		"$::botnick ne fais "										"je ne fais "\
		"$::botnick met "												"je mets "\
		"$::botnick ne met "										"je ne mets "\
		"$::botnick prend "											"je prends "\
		"$::botnick ne prend "									"je ne prends "\
		"$::botnick avait "											"j'avais "\
		"$::botnick l'avait "										"je l'avais "\
		"$::botnick n'avait "										"je n'avais "\
		"$::botnick tait "											"j'tais "\
		"$::botnick l'tait "										"je l'tais "\
		"$::botnick n'tait "										"je n'tais "\
		"$::botnick faisait "										"je faisais "\
		"$::botnick ne faisait "								"je ne faisais "\
		"$::botnick perd "											"je perds "\
		"$::botnick ne perd "										"je ne perds "\
		"$::botnick est "												"je suis "\
		"$::botnick n'est "											"je ne suis "\
		"$::botnick tu vas "										"je vais "\
		"$::botnick tu ne vas "									"je ne vais "\
		"$::botnick tu va "											"je vais "\
		"$::botnick tu ne va "									"je ne vais "\
		"$::botnick va "												"je vais "\
		"$::botnick ne va "											"je ne vais "\
		"$::botnick a "													"j'ai "\
		"$::botnick n'a "												"je n'ai "\
		"$::botnick sait"												"je sais"\
		"$::botnick sais "											"tu sais "\
		"$::botnick ne sait "										"je ne sais "\
		"$::botnick ne sais "										"tu ne sais "\
		"$::botnick se "												"je me "\
		"$::botnick s'il"												"$::botnick s'il"\
		"$::botnick s'"													"je m'"\
		"$::botnick ne s'"											"je ne m'"\
		"$::botnick ne se "											"je ne me "\
		"$::botnick apprend "										"j'apprends "\
		"$::botnick n'apprend "									"je n'apprends "\
		"ce que $::botnick"											"ce que je"\
		"je te parle $::botnick"								"je te parle"\
		"te parle $::botnick"										"te parle"\
		"pas l $::botnick"											"pas l"\
		"n'est ce pas $::botnick"								"n'est-ce pas"\
		"n'est-ce pas $::botnick"								"n'est-ce pas"\
		"toi $::botnick"												"moi"\
		"moi $::botnick"												"toi"\
		"$::botnick ?"													"?"\
		"non $::botnick"												"non"\
		"nan $::botnick"												"nan"\
		"ou $::botnick"												"ou"\
		"u $::botnick"													"u"\
		"ouais $::botnick"											"ouais"\
		"oui $::botnick"												"oui"\
		"bon $::botnick"												"bon"\
		"sais $::botnick"												"sais"\
		"ptdr $::botnick"												"ptdr"\
		"mdr $::botnick"												"mdr"\
		"lol $::botnick"												"lol"\
	] $text]
	# on supprime le " " en dbut de ligne
	set text [regsub {^ } $text ""]
	# on supprime le "." en fin de ligne sauf s'il est prcd d'un autre "."
	set text [regsub {([^\.])\.$} $text {\1}]
	# supprime la plupart des $::botnick restants dans le texte, sauf quand la construction
	# de la phrase le rend indispensable.
	set text [regsub -all -nocase "(^| )(((de|avec|vers|sur|sous|par|pour|en|dans|ce|le|une?|et||a) $::botnick)|$::botnick) ?(\[\\.\\?,!:;=\]|\\^+|\[:X;=8>\]\[<D\\(\\)\\\[\\\]\\{\\}p\]|$)" $text {\1\3 \5}]
	set text [regsub -all -nocase "^$::botnick " $text ""]
	if { $megahal_interface::substitute_all_nicks } {
		# on repre si la phrase contient des nicks de personnes prsentes sur le chan, et si oui
		# on remplace par __USERNICKmd5__ (le md5 sert  ne pas avoir des centaines de fois l'entre
		# "__USERNICK__" dans le brain, auquel cas il aurait un poids norme et serait souvent
		# utilis par l'I.A. pour construire des phrases.
		set split_text [split $text]
		foreach current_nick [chanlist $chan] {
			if { [lsearch -nocase [subst $megahal_interface::nick_substitution_exclusion_list] $current_nick] != -1 } {
				continue
			} else {
				foreach index [lsearch -all -nocase -exact $split_text $current_nick] {
					lset split_text $index "__USERNICK[md5 $current_nick]__"
				}
			}
		}
  	set text [join $split_text]
	}
	return $text
}

###
### Traitement des rponses avant affichage
###
proc megahal_interface::moulinex_out {nick chan text} {
	if { (($megahal_interface::DEBUGMODE_chan eq "*") || ($chan eq $megahal_interface::DEBUGMODE_chan)) && ([lindex $megahal_interface::DEBUGMODE 0]) } {
		putlog "\00304\[MEGAHAL DEBUG\]\003 \00306i!i\003\00313!i!\003\00314 dump \003moulinex_out\00314 : $nick | $chan | $text\003"
	}
	set unmodified_text $text
	# remarque : MegaHAL envoie de l'utf-8
	set text [encoding convertfrom utf-8 $text]
	# supprime Botnick en dbut de phrase si suivi par > : , . ...
	set text [regsub -nocase "^@?$::botnick ?(>+|:|~||,|\\.+) ?" $text ""]
	# ajout d'un " " en dbut de ligne (il nous servira de repre dans les string map)
	set text " $text"
	# ajout d'un "." en fin de ligne (il nous servira de repre dans les string map)
	if { [string index $text end] ne "." } { set text "$text." }
	# substitution du nick de l'eggdrop par le nick de la personne  qui il rpond
	if { [rand 101] <= $megahal_interface::nickswitchrate } { set text [string map -nocase "$::botnick [split $nick]" $text] }
	# substitutions diverses vous pouvez utiliser les variables $::botnick, $nick et $chan
	set text [string map -nocase [list\
		"I am utterly speechless!"							"\003[set ::mega_color1]les mots me manquent...\003"\
		"I forgot what I was going to say!"			"\003[set ::mega_color1]j'ai... oubli ce que je voulais dire\003"\
		" pourquoi"														"parce que"\
		" de $::botnick"												" euh..."\
		"avec $::botnick"												"avec moi"\
		"vers $::botnick"												"vers moi"\
		"sur $::botnick"												"sur moi"\
		"sous $::botnick"												"sous moi"\
		"par $::botnick"												"par moi"\
		"pour $::botnick"												"pour moi"\
		"en $::botnick"													"en moi"\
		"dans $::botnick"												"en moi"\
		" ce $::botnick"												" quand mme"\
		"voil $::botnick"											"me voil"\
		"voila $::botnick"											"me voil"\
		"le $::botnick est "										"je suis "\
		"le $::botnick n'est "									"je ne suis "\
		" et $::botnick"												" et moi"\
		" $::botnick"													" moi"\
		" a $::botnick"													"  moi"\
		"c'est $::botnick"											"c'est moi"\
		"c'tait $::botnick"										"c'tait moi"\
		"c'etait $::botnick"										"c'etait moi"\
		" pas $::botnick"												" pas moi"\
		"comme $::botnick"											"comme moi"\
		"$::botnick il a "											"j'ai "\
		"$::botnick il n'a "										"je n'ai "\
		"$::botnick il est interdit"						"il est interdit"\
		"$::botnick il est dconseill"					"il est dconseill"\
		"$::botnick il est conseill"						"il est conseill"\
		"$::botnick il est formellement"				"il est formellement"\
		"$::botnick il est "										"je suis "\
		"$::botnick il n'est "									"je ne suis "\
		"$::botnick il faut "										"il faut "\
		"$::botnick tu as "											"j'ai "\
		"$::botnick tu n'as "										"je n'ai "\
		"$::botnick tu est "										"je suis "\
		"$::botnick tu n'est "									"je ne suis "\
		"$::botnick tu es "											"je suis "\
		"$::botnick tu n'es "										"je ne suis "\
		"$::botnick fait "											"je fais "\
		"$::botnick ne fait "										"je ne fais "\
		"$::botnick fais "											"je fais "\
		"$::botnick ne fais "										"je ne fais "\
		"$::botnick met "												"je mets "\
		"$::botnick ne met "										"je ne mets "\
		"$::botnick prend "											"je prends "\
		"$::botnick ne prend "									"je ne prends "\
		"$::botnick avait "											"j'avais "\
		"$::botnick l'avait "										"je l'avais "\
		"$::botnick n'avait "										"je n'avais "\
		"$::botnick tait "											"j'tais "\
		"$::botnick l'tait "										"je l'tais "\
		"$::botnick n'tait "										"je n'tais "\
		"$::botnick faisait "										"je faisais "\
		"$::botnick ne faisait "								"je ne faisais "\
		"$::botnick perd "											"je perds "\
		"$::botnick ne perd "										"je ne perds "\
		"$::botnick est "												"je suis "\
		"$::botnick n'est "											"je ne suis "\
		"$::botnick tu vas "										"je vais "\
		"$::botnick tu ne vas "									"je ne vais "\
		"$::botnick tu va "											"je vais "\
		"$::botnick tu ne va "									"je ne vais "\
		"$::botnick va "												"je vais "\
		"$::botnick ne va "											"je ne vais "\
		"$::botnick a "													"j'ai "\
		"$::botnick n'a "												"je n'ai "\
		"$::botnick sait"												"je sais"\
		"$::botnick sais "											"je sais "\
		"$::botnick ne sait"										"je ne sais"\
		"$::botnick ne sais "										"je ne sais "\
		"$::botnick se "												"je me "\
		"$::botnick s'il"												"$::botnick s'il"\
		"$::botnick s'"													"je m'"\
		"$::botnick ne s'"											"je ne m'"\
		"$::botnick ne se "											"je ne me "\
		"$::botnick apprend "										"j'apprends "\
		"$::botnick n'apprend "									"je n'apprends "\
		"ce que $::botnick"											"ce que je"\
		"je te parle $::botnick"								"tu me parles"\
		"te parle $::botnick"										"me parle"\
		"je te parle"														"tu me parles"\
		"tu me parles"													"je te parle"\
		"$::botnick $::botnick $::botnick."			"mmh ?"\
		"pas l $::botnick"											"pas l"\
		"n'est ce pas $::botnick"								"n'est-ce pas"\
		"n'est-ce pas $::botnick"								"n'est-ce pas"\
		"$::botnick tu "												"tu "\
		"$::botnick je te "											"tu me "\
		"$::botnick je t'ai "										"tu m'as "\
		"$::botnick je t'"											"tu m'"\
		"$::botnick je "												"je "\
		"$::botnick j'"													"tu "\
		"toi $::botnick"												"moi"\
		"moi $::botnick"												"toi"\
		"non $::botnick"												"non"\
		"ou $::botnick"												"ou"\
		"oui $::botnick"												"oui"\
		"bon $::botnick"												"bon"\
		"sais $::botnick"												"sais"\
		"ptdr $::botnick"												"ptdr"\
		"mdr $::botnick"												"mdr"\
		"lol $::botnick"												"lol"\
		" susi "																" suis "\
		"sa va"																	"a va"\
	] $text]
	set text [string map -nocase [list\
		"que je m'en vais"											"que je m'en aille"\
		"pour que je vais"											"pour que j'aille"\
		"pour que je suis"											"pour que je sois"\
		"pour que j'ai "												"pour que j'aie "\
		"pour que je viens"											"pour que je vienne"\
		"faut que je viens"											"faut que je vienne"\
		"faut que je suis"											"faut que je sois"\
		"faut que j'ai "												"faut que j'aie "\
		"faut que je vais"											"faut que j'aille"\
		"faut que je veux"											"faut que je veuille"\
		"faut que je veut"											"faut que je veuille"\
		"faut que je fais "											"faut que je fasse"\
		"faut que je fait "											"faut que je fasse"\
		"que tu le dit"													"que tu le dises"\
		"que tu le dis "												"que tu le dises "\
		"que je le dit"													"que je le dise"\
		"que je le dis "												"que je le dise "\
		"qu'il le dit"													"qu'il le dise"\
		"qu'il le dis "													"qu'il le dis "\
		"tu t'appelles"													"je m'appelle"\
		"je m'appelle"													"tu t'appelles"\
		"je suis $::botnick"										"c'est moi $::botnick"\
		"je est "																"je suis "\
		"je es "																"je suis "\
		"je n'est "															"je ne suis "\
		"je a "																	"j'ai "\
		"je n'a "																"je n'ai "\
		"je s'"																	"je m'"\
		"je as "																"j'ai "\
		"tu ai "																"tu as "\
		"a je"																	"je"\
		" ca je"																" a je"\
	] $text]
	# correction de la casse/soulignement de certains smileys
	set text [string map -nocase {
		" oo "																	" oO "
		" oo."																	" oO."
		"o.o"																		"o.O"
		"o_o"																		"o_O"
		"xd"																		"XD"
		"x)"																		"X)"
		"x]"																		"X]"
		":d"																		":D"
		""																		"\037\037"
	} $text]
	if { $megahal_interface::substitute_all_nicks } {
		# on remplace les __USERNICK__ par des nicks alatoires pris sur le chan
		if { [set index_list [lsearch -all [set split_text [split $text]] {*__usernick*__*}]] != -1 } {
			set userlist [megahal_interface::randomize_list [chanlist $chan]]
			set userindex 0
			foreach index $index_list {
				while { [lsearch -nocase [subst $megahal_interface::nick_substitution_exclusion_list] [lindex $userlist $userindex]] != -1 } {
					incr userindex
				}
				lset split_text $index [lindex $userlist $userindex]
				incr userindex
			}
			set text [join $split_text]
		}
	}
	# Si ncessaire, on corrige la casse des caractres dans les nicks des
	# personnes prsentes sur le chan
	foreach current_nick [chanlist $chan] {
		set text [string map {"  " " "} [string map -nocase [list\
			" $current_nick " " $current_nick "\
			"$current_nick." "$current_nick."\
			".$current_nick" ".$current_nick"\
			"$current_nick;" "$current_nick;"\
			";$current_nick" ";$current_nick"\
			"$current_nick," "$current_nick,"\
			",$current_nick" ",$current_nick"\
			"$current_nick:" "$current_nick:"\
			":$current_nick" ":$current_nick"\
			"$current_nick!" "$current_nick!"\
			"!$current_nick" "!$current_nick"\
			"$current_nick?" "$current_nick?"\
			"?$current_nick" "?$current_nick"\
		] [string map {" " "  "} $text]]]
	}
	# on supprime le " " en dbut de ligne
	set text [regsub {^ } $text ""]
	# on supprime le "." en fin de ligne sauf s'il est prcd d'un autre "."
	set text [regsub {([^\.])\.$} $text {\1}]
	# supprime la plupart des $::botnick restants dans la rponse, sauf quand la construction
	# de la phrase le rend indispensable.
	set text [regsub -all -nocase "(^| )(((de|avec|vers|sur|sous|par|pour|en|dans|ce|le|une?|et||a) $::botnick)|$::botnick) ?(\[\\.\\?,!:;=\]|\\^+|\[:X;8>\]\[<D\\(\\)\\\[\\\]\\{\\}p\]|$)" $text {\1\3 \5}]
	set text [regsub -all -nocase "^$::botnick " $text ""]
	# ajoute un espace devant ? et ! si il n'y en a pas
	set text [regsub -all {([^\s!\?])\s?(\?|!)} $text {\1 \2}]
	# supprime l'espace devant . , et ; si il y en a un
	set text [regsub -all {([^\s])\s?(\.|,|;)} $text {\1\2}]
	if { (($megahal_interface::DEBUGMODE_chan eq "*") || ($chan eq $megahal_interface::DEBUGMODE_chan)) && ([lindex $megahal_interface::DEBUGMODE 4]) && ([string compare -nocase [string map {"." "" ";" "" "," "" ":" "" "!" "" "?" ""} $text] [string map {"." "" ";" "" "," "" ":" "" "!" "" "?" ""} $unmodified_text]] != 0) } {
		putlog "\00304\[MEGAHAL DEBUG\]\003 \00307\[$chan\]\003 \00314 $unmodified_text\003"
		putlog "\00304\[MEGAHAL DEBUG\]\003 \00304--talk-->\003\00315 $text\003"
	}
	return $text
}

###
### Si l'eggdrop vient juste de se connecter au serveur, l'I.A. est active
### aprs un dlai afin d'viter l'encombrement des files d'attente de messages.
###
proc megahal_interface::resume_on_connect {args} {
	after [expr $megahal_interface::IA_activation_delay * 1000] [list bind pubm - * megahal_interface::process]
	return
}

###
### Si l'eggdrop est dconnect du serveur, l'I.A. est mise en pause.
###
proc megahal_interface::pause_on_disconnect {args} {
	if { [binds megahal_interface::process] ne "" } {
		unbind pubm - * megahal_interface::process
	}
	return
}

###
### Backup quotidien des bases de donnes
###
proc megahal_interface::backup_db {min hour day month year} {
	putlog "\00314\[$megahal_interface::scriptname\]\003 Sauvegarde des bases de donnes..."
	if { [file exists "megahal.brn"] } {
		file copy -force "megahal.brn" "megahal.brn.bak"
	}
	if { [file exists "megahal.dic"] } {
		file copy -force "megahal.dic" "megahal.dic.bak"
	}
	if { [file exists "megahal.phr"] } {
		file copy -force "megahal.phr" "megahal.phr.bak"
	}
}

###
### Binds
###
namespace eval megahal_interface {
	bind pub $help_auth $help_cmd megahal_interface::pub_help
	bind pub $masterswitch_auth $masterswitch_cmd megahal_interface::pub_masterswitch
	bind pub $learnstate_auth $learnstate_cmd megahal_interface::pub_learnstate
	bind pub $respondstate_auth $respondstate_cmd megahal_interface::pub_respondstate
	bind pub $chatterstate_auth $chatterstate_cmd megahal_interface::pub_chatterstate
	bind pub $replyrate_auth $replyrate_cmd megahal_interface::pub_replyrate
	bind pub $keyreplyrate_auth $keyreplyrate_cmd megahal_interface::pub_keyreplyrate
	bind pub $forget_auth $forget_cmd megahal_interface::pub_forget
	bind pub $forgetword_auth $forgetword_cmd megahal_interface::pub_forgetword
	bind pub $seekstatement_auth $seekstatement_cmd megahal_interface::pub_seekstatement
	bind pub $countword_auth $countword_cmd megahal_interface::pub_countword
	bind pub $learnfile_auth $learnfile_cmd megahal_interface::pub_learnfile
	bind pub $savebrain_auth $savebrain_cmd megahal_interface::pub_savebrain
	bind pub $reloadbrain_auth $reloadbrain_cmd megahal_interface::pub_reloadbrain
	bind pub $reloadphrases_auth $reloadphrases_cmd megahal_interface::pub_reloadphrases
	bind pub $trimbrain_auth $trimbrain_cmd megahal_interface::pub_trimbrain
	bind pub $lobotomy_auth $lobotomy_cmd megahal_interface::pub_lobotomy
	bind pub $restorebrain_auth $restorebrain_cmd megahal_interface::pub_restorebrain
	bind pub $chanstatus_auth $chanstatus_cmd megahal_interface::pub_chanstatus
	bind pub $braininfo_auth $braininfo_cmd megahal_interface::pub_braininfo
	bind pub $memusage_auth $memusage_cmd megahal_interface::pub_memusage
	bind pub $treesize_auth $treesize_cmd megahal_interface::pub_treesize
	bind pub $viewbranch_auth $viewbranch_cmd megahal_interface::pub_viewbranch
	bind time - "35 * * * *" megahal_interface::auto_savebrain
	bind time - "[lindex $megahal_interface::backuptime 1] [lindex $megahal_interface::backuptime 0] * * *" megahal_interface::backup_db
	bind evnt - prerehash megahal_interface::uninstall
	# Binds destins  forcer une sauvegarde du brain au cas o il arrive quelque
	# chose  l'eggdrop qui pourrait provoquer la perte du brain non-sauvegard.
	bind evnt - prerehash megahal_interface::on_event_savebrain
	bind evnt - prerestart megahal_interface::on_event_savebrain
	bind evnt - sigquit megahal_interface::on_event_savebrain
	bind evnt - sighup megahal_interface::on_event_savebrain
	bind evnt - sigterm megahal_interface::on_event_savebrain
	bind evnt - sigill megahal_interface::on_event_savebrain
	bind evnt - disconnect-server megahal_interface::on_event_savebrain
	# Bind destin  activer l'I.A. aprs un dlai  la connection au serveur.
	bind evnt - init-server megahal_interface::resume_on_connect
	# Bind destin  mettre l'I.A. en pause en cas de dconnection du serveur.
	bind evnt - disconnect-server megahal_interface::pause_on_disconnect
	# Si l'eggdrop est dj connect au serveur, l'I.A. est immdiatement disponible.
	if { $::server ne "" } { bind pubm - * megahal_interface::process }
}


putlog "\002$megahal_interface::scriptname v$megahal_interface::version\002 (2010 MenzAgitat) a t charg"
